Imports System.Data.SqlClient
Public Class Form1
    Inherits System.Windows.Forms.Form
    Const SQL_CONNECTION = "Data Source=localhost;Initial Catalog=Northwind;" & _
        "User ID=sa;"
    Const SQL_COUNTRIES = "SELECT DISTINCT Suppliers.Country FROM Suppliers"


    Private Sub FillComboBoxFromDataSet()

        ' Purpose:  Populate the combo box with countries list, from a DataSet

        Dim dsCountries As DataSet        ' Form-level DataSet object

        ' Load list of countries into the combo box, from the DataSet
        dsCountries = ListCountriesInDataSet()

        ' Bind the combo box, cboCountries, to the DataSet
        cboCountries.DataSource = dsCountries.Tables("Countries")
        cboCountries.DisplayMember = "Country"

    End Sub

    Public Function ListCountriesInDataSet() As System.Data.DataSet

        ' Purpose:  Return the Supplier Countries, in a DataSet

        Dim sqlConn As SqlConnection
        Dim sqlCmd As SqlCommand
        Dim sqlAdapt As SqlDataAdapter

        ' New Dataset, named "ListOfCountries"
        Dim rowDataSet As New DataSet("ListOfCountries")

        Try
            ' Create a new connection object
            sqlConn = New SqlConnection(SQL_CONNECTION)

            ' Create a new command object
            sqlCmd = New SqlCommand(SQL_COUNTRIES, sqlConn)

            ' Open the connection
            sqlConn.Open()

            ' Open a DataAdapter object, using the command object
            sqlAdapt = New SqlDataAdapter(sqlCmd)

            ' Execute the command and retrieve the records in the DataSet
            ' The DataTable is named "Countries"
            sqlAdapt.Fill(rowDataSet, "Countries")

        Catch e As SqlException
            MsgBox("Error " & e.Number & ": " & e.Message & " [" & _
               e.Source & "]")
        Finally
            sqlConn.Close() ' The connection is not needed anymore
        End Try

        Return (rowDataSet)

    End Function



#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents cboCountries As System.Windows.Forms.ComboBox
    Friend WithEvents Button1 As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Button1 = New System.Windows.Forms.Button()
        Me.cboCountries = New System.Windows.Forms.ComboBox()
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(8, 32)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(96, 24)
        Me.Button1.TabIndex = 1
        Me.Button1.Text = "Load Countries"
        '
        'cboCountries
        '
        Me.cboCountries.DropDownWidth = 256
        Me.cboCountries.Location = New System.Drawing.Point(8, 8)
        Me.cboCountries.Name = "cboCountries"
        Me.cboCountries.Size = New System.Drawing.Size(256, 21)
        Me.cboCountries.TabIndex = 0
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(272, 61)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Button1, Me.cboCountries})
        Me.Name = "Form1"
        Me.Text = "Demo"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        FillComboBoxFromDataSet()
    End Sub

    
End Class
