using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace EnforceConstraintsExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Read XML Schema containing table structure.
			DataSet ds = new DataSet("XMLDataSet");
			ds.ReadXmlSchema("C:\\AuthorsSchema.XML");

			// Add a unique constraint on the au_id column
			ds.Tables[0].Constraints.Add("ConstraintID",ds.Tables[0].Columns["au_id"],true);

			// Add the first record
			DataRow dr = ds.Tables[0].NewRow();
			dr["au_id"] = "222-22-2222";
			dr["au_fname"] = "Fabio Claudio";
			dr["au_lname"] = "Ferracchiati";
			dr["contract"] = 1;
			ds.Tables[0].Rows.Add(dr);
			ds.Tables[0].AcceptChanges();

			// If you set this to true and then try to add the records
			// below an exception will be raised. False value ignore the
			// constraint rule for this table.
			ds.EnforceConstraints = false;

			// I can insert another record with the same primary key
			dr = ds.Tables[0].NewRow();
			dr["au_id"] = "222-22-2222";
			dr["au_fname"] = "Fabio Claudio";
			dr["au_lname"] = "Ferracchiati";
			dr["contract"] = 1;
			ds.Tables[0].Rows.Add(dr);
			ds.Tables[0].AcceptChanges();
		}
	}
}
