using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Example2
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnAddRow;
		protected System.Web.UI.WebControls.DataGrid dgAuthors;
		protected System.Web.UI.WebControls.Button btnUndo;
		protected System.Web.UI.WebControls.Button btnConfirm;
		protected SqlDataAdapter da;
		protected System.Data.DataSet ds;
	
		public WebForm1()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Page.IsPostBack)
			{
				// Create a connection object
				SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=WroxDB");
			
				// Create a data adapter specifying the query to execute
				da = new SqlDataAdapter("SELECT AuthorID, Author_FirstName, Author_LastName FROM tabAuthors",dbConn);

				SqlCommandBuilder sql = new SqlCommandBuilder(da);

				// Create a dataset and fill it
				da.Fill(ds);

				Session["ds"] = ds;
				Session["da"] = da;

				// Associate the filled dataset to a datagrid
				dgAuthors.DataSource = ds;
			}
			else
			{
				dgAuthors.DataSource = (DataSet)Session["ds"];
			}

			dgAuthors.DataBind();
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ds = new System.Data.DataSet();
			((System.ComponentModel.ISupportInitialize)(this.ds)).BeginInit();
			this.btnConfirm.Click += new System.EventHandler(this.btnConfirm_Click);
			this.btnAddRow.Click += new System.EventHandler(this.btnAddRow_Click);
			this.btnUndo.Click += new System.EventHandler(this.btnUndo_Click);
			// 
			// ds
			// 
			this.ds.DataSetName = "dsAuthors";
			this.ds.Locale = new System.Globalization.CultureInfo("en-US");
			this.Load += new System.EventHandler(this.Page_Load);
			((System.ComponentModel.ISupportInitialize)(this.ds)).EndInit();

		}
		#endregion

		private void btnAddRow_Click(object sender, System.EventArgs e)
		{
			// Add a row to the dataset
			DataSet ds = (DataSet)Session["ds"];

			// Check if the record I'm being to insert already exists
			if (ds.Tables[0].Rows.Count < 6)
			{
				DataRow r;
				r = ds.Tables[0].NewRow();
				r["AuthorID"] = 6;
				r["Author_FirstName"] = "Lee";
				r["Author_LastName"] = "Witney";
				ds.Tables[0].Rows.Add(r);
		
				// Show in the DataGrid the new content
				dgAuthors.DataBind();
			}
		}

		private void btnUndo_Click(object sender, System.EventArgs e)
		{
			// Retrieve the dataset
			DataSet ds = (DataSet)Session["ds"];

			// Reject its changes
			ds.RejectChanges();

			// Update the DataGrid
			dgAuthors.DataBind();
		}

		private void btnConfirm_Click(object sender, System.EventArgs e)
		{
			// Retrieve the dataset
			DataSet ds = (DataSet)Session["ds"];
			// Retrieve the data adapter
			SqlDataAdapter da = (SqlDataAdapter)Session["da"];

			// Retrieve the changes
			DataSet dsTemp = ds.GetChanges();

			if(dsTemp != null)
			{
				// Update the database
				da.Update(ds);

				// Commit the records in the DataSet
				ds.AcceptChanges();

				// Print to video
				Response.Write("Added a records to the database");
			}
			else
			{
				Response.Write("No new records found!");
			}
		}
	}
}
