using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace AcceptChanges_NewRow_Example
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Open the connection
			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");

			try
			{
				// Create Authors DataTable
				DataTable dtAuthors = new DataTable("Authors");

				// Create a DataAdapter to fill the table
				SqlDataAdapter daAuthors = new SqlDataAdapter("SELECT au_id,au_fname,au_lname,contract FROM authors",dbConn);
				daAuthors.Fill(dtAuthors);
							
				// Create a command builder to implement SQL insert command
				// automatically
				SqlCommandBuilder sqlCB = new SqlCommandBuilder(daAuthors);

				// Create a new row
				DataRow drNewAuthor;
				drNewAuthor = dtAuthors.NewRow();

				// It has the same table schema
				drNewAuthor["au_id"] = "222-22-2222";
				drNewAuthor["au_fname"] = "Fabio Claudio";
				drNewAuthor["au_lname"] = "Ferracchiati";
				drNewAuthor["contract"] = 1;

				// Add the new row to the collection contained
				// in the DataTable
				dtAuthors.Rows.Add(drNewAuthor);

				// Update the database records
				daAuthors.Update(dtAuthors);

				// Accept DataTable changes
				dtAuthors.AcceptChanges();
			}
			catch (Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}
	}
}
