using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace CaseSensitiveExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			try
			{
				SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");

				// Create Authors DataTable
				DataTable dtAuthors = new DataTable("Authors");

				// Create a DataAdapter to fill the table
				SqlDataAdapter daAuthors = new SqlDataAdapter("SELECT au_id,au_fname,au_lname FROM authors",dbConn);
				daAuthors.Fill(dtAuthors);

				// I'm looking for a record without case-sensitive comparison
				dtAuthors.CaseSensitive = false;
				DataRow[] r = dtAuthors.Select("au_lname = 'karsen'");

				// Print to video
				if (r.Length > 0)
					Console.WriteLine("Found: " + r[0]["au_lname"]);
				else
					Console.WriteLine("Nothing found");

				// And with case-sensitive comparison
				dtAuthors.CaseSensitive = true;
				r = dtAuthors.Select("au_lname = 'karsen'");

				// Print to video
				if (r.Length > 0)
					Console.WriteLine("Found: " + r[0]["au_lname"]);
				else
					Console.WriteLine("Nothing found");
			}
			catch (Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}
	}
}
