using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace DeleteExample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dgAuthors;
		private DataView dvAuthors;
		private DataView dvAuthorsTemp;
		private System.ComponentModel.Container components = null;
		private DataTable dtAuthors;
		private DataTable dtAuthorsTemp;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");

			// Create Authors DataTable
			dtAuthors = new DataTable("Authors");
			dtAuthorsTemp = new DataTable("AuthorsTemp");
			dvAuthorsTemp = new DataView(dtAuthors);

			// Create a DataAdapter to fill the tables
			SqlDataAdapter daAuthors = new SqlDataAdapter("SELECT au_id,au_fname,au_lname,contract FROM authors",dbConn);
			daAuthors.Fill(dtAuthors);
			daAuthors.Fill(dtAuthorsTemp);
			dvAuthors.Table = dtAuthors;

			// Only delete operation is possible
			dvAuthors.AllowEdit = false;
			dvAuthors.AllowNew = false;

			// The temporary dataview points to the same set of records
			dvAuthorsTemp.Table = dtAuthorsTemp;

			// Set the DataSource to point to data contained
			// in the DataView object
			dgAuthors.DataSource = dvAuthors;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dgAuthors = new System.Windows.Forms.DataGrid();
			this.dvAuthors = new System.Data.DataView();
			((System.ComponentModel.ISupportInitialize)(this.dgAuthors)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dvAuthors)).BeginInit();
			this.SuspendLayout();
			// 
			// dgAuthors
			// 
			this.dgAuthors.CaptionText = "Authors";
			this.dgAuthors.DataMember = "";
			this.dgAuthors.Location = new System.Drawing.Point(8, 0);
			this.dgAuthors.Name = "dgAuthors";
			this.dgAuthors.Size = new System.Drawing.Size(280, 272);
			this.dgAuthors.TabIndex = 0;
			// 
			// dvAuthors
			// 
			this.dvAuthors.ListChanged += new System.ComponentModel.ListChangedEventHandler(this.OnListChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.dgAuthors});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dgAuthors)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dvAuthors)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void OnListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
		{

			// Not allowed if the first row is deleted
			if (dvAuthorsTemp[dgAuthors.CurrentRowIndex].Row["au_id"].ToString() == "172-32-1176")
				dtAuthors.RejectChanges();
			else
			{
				// Else remove even the record from the in-memory dataview
				dvAuthorsTemp[dgAuthors.CurrentRowIndex].Delete();
				dtAuthorsTemp.AcceptChanges();
			}
		}
	}
}
