using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace OnColumnChangedAndChangingExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");

			// Create Authors DataTable
			DataTable dtAuthors = new DataTable("Authors");

			// Create a DataAdapter to fill the table
			SqlDataAdapter daAuthors = new SqlDataAdapter("SELECT au_id,au_fname,au_lname,contract FROM authors",dbConn);
			daAuthors.Fill(dtAuthors);

			dtAuthors.ColumnChanged += new DataColumnChangeEventHandler(OnColumnChanged);
			dtAuthors.ColumnChanging += new DataColumnChangeEventHandler(OnColumnChanging);
			
			// Create a new row
			DataRow drNewAuthor;
			drNewAuthor = dtAuthors.NewRow();

			// It has the same table schema
			drNewAuthor["au_id"] = "222-22-2222";
			drNewAuthor["au_fname"] = "Fabio Claudio";
			drNewAuthor["au_lname"] = "Ferracchiati";
			drNewAuthor["contract"] = 1;
		}

		protected static void OnColumnChanged(Object sender, DataColumnChangeEventArgs args)
		{
			Console.WriteLine("Column " + args.Column.ToString() + " has changed");
		}

		protected static void OnColumnChanging(Object sender, DataColumnChangeEventArgs args)
		{
			Console.WriteLine("Column " + args.Column.ToString() + " is changing");
		}
	}
}
