using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace RowStateFilterExample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dgAuthors;
		private System.Windows.Forms.DataGrid dgAuthorsRemoved;
		private DataView dvAuthors;
		private DataView dvAuthorsRemoved;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");

			// Create Authors DataTable
			DataTable dtAuthors = new DataTable("Authors");

			// Create a DataAdapter to fill the table
			SqlDataAdapter daAuthors = new SqlDataAdapter("SELECT au_id,au_fname,au_lname,contract FROM authors",dbConn);
			daAuthors.Fill(dtAuthors);

			// Create the DataView
			this.dvAuthors = new DataView(dtAuthors);

			// Create the DataView for deleted rows
			this.dvAuthorsRemoved = new DataView(dtAuthors);

			// Set the DataSource to point to data contained
			// in the DataView object
			dgAuthors.DataSource = dvAuthors;

			// Retrieve all the rows with Deleted state
			dvAuthorsRemoved.RowStateFilter = DataViewRowState.Deleted;
			dgAuthorsRemoved.DataSource = dvAuthorsRemoved;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dgAuthors = new System.Windows.Forms.DataGrid();
			this.dgAuthorsRemoved = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.dgAuthors)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dgAuthorsRemoved)).BeginInit();
			this.SuspendLayout();
			// 
			// dgAuthors
			// 
			this.dgAuthors.CaptionText = "Authors";
			this.dgAuthors.DataMember = "";
			this.dgAuthors.Location = new System.Drawing.Point(8, 8);
			this.dgAuthors.Name = "dgAuthors";
			this.dgAuthors.Size = new System.Drawing.Size(592, 112);
			this.dgAuthors.TabIndex = 0;
			// 
			// dgAuthorsRemoved
			// 
			this.dgAuthorsRemoved.CaptionText = "Authors Removed";
			this.dgAuthorsRemoved.DataMember = "";
			this.dgAuthorsRemoved.Location = new System.Drawing.Point(8, 128);
			this.dgAuthorsRemoved.Name = "dgAuthorsRemoved";
			this.dgAuthorsRemoved.Size = new System.Drawing.Size(592, 128);
			this.dgAuthorsRemoved.TabIndex = 1;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 261);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.dgAuthorsRemoved,
																		  this.dgAuthors});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dgAuthors)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dgAuthorsRemoved)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
