using System;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace DayOfDotNet
{
	public class SortingDataGrid1 : Page
	{
		protected DataGrid DataGrid1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!Page.IsPostBack)
			{
				//On the first request, Bind the DataGrid
				BindData(null);
			}
		}

		private void BindData(string _sortExpression)
		{
			//Create the DataView and cache it to improvwe performance
			//BooksData _booksData = new BooksData();
			BooksData _booksData = new BooksData();
			DataView _data = _booksData.GetAllBooks();
			
			//If the _sortExpression has a value, sort the
			//DataView, otherwise just bind the DataGrid
			if(_sortExpression != null)
			{
				_data.Sort = _sortExpression;
			}
			
			//Bind the DataGrid
			DataGrid1.DataSource = _data;
			DataGrid1.DataBind();
		}
		
		protected void SortCommand_OnClick(object sender, DataGridSortCommandEventArgs e)
		{
			//When a sort link is clicked, bind the 
			//DataGrid using the SortExpression
			BindData(e.SortExpression);
		}
	}
}