Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration

Namespace DayOfDotNet

	Public Class BooksData
	
		' Returns a DataView containing all the basic book info.
		Public Function GetAllBooks() As DataView
			Dim con As SqlConnection = New SqlConnection(ConfigurationSettings.AppSettings("DotNetBooksConString"))
			Dim sda As SqlDataAdapter = New SqlDataAdapter("GetAllBooks", con)
			sda.SelectCommand.CommandType = CommandType.StoredProcedure
			Dim ds As DataSet = New DataSet()
			sda.Fill(ds, "Books")
			Return ds.Tables("Books").DefaultView
		End Function

		' Returns a DataSet containing two DataTables
		'- "Books" and "Authors"
		'- for a specific book, using the ISBN number.
		Public Function GetBookInfo(isbn As String) As DataSet
			Dim con As SqlConnection = New SqlConnection(ConfigurationSettings.AppSettings("DotNetBooksConString"))
			Dim sda As SqlDataAdapter = New SqlDataAdapter("GetBookInfo", con)
			sda.SelectCommand.CommandType = CommandType.StoredProcedure
			sda.SelectCommand.Parameters.Add(New SqlParameter("@isbn", SqlDbType.VarChar, 14)).Value = isbn
			Dim ds As DataSet = New DataSet()
			sda.Fill(ds)
			ds.Tables(0).TableName="Books"
			ds.Tables(1).TableName="Authors"
			Return ds
		End Function
		
		' Returns a DataSet containing two DataTables
		'- "Table" (Books) and "Table1" (Authors) 
		Public Function GetAllBookInfoDataSet() As DataSet
			Dim con As SqlConnection = New SqlConnection(ConfigurationSettings.AppSettings("DotNetBooksConString"))
			Dim sda As SqlDataAdapter = New SqlDataAdapter("GetAllBooks", con)
			sda.SelectCommand.CommandType = CommandType.StoredProcedure
			'sda.SelectCommand.Parameters.Add(New SqlParameter("@isbn", SqlDbType.VarChar, 14)).Value = isbn
			Dim ds As DataSet = New DataSet()
			sda.Fill(ds, "Books")
			sda.SelectCommand.CommandText = "GetAllAuthorsByBooks"
			sda.Fill(ds, "Authors")
			
			Dim primaryKey(1) As DataColumn
			primaryKey(0) = ds.Tables("Books").Columns("ISBN")
			ds.Tables("Books").PrimaryKey = primaryKey
			
			Dim booksToAuthors As DataRelation = _
				New DataRelation("BooksToAuthors", _
					ds.Tables("Books").Columns("ISBN"), _
					ds.Tables("Authors").Columns("ISBN") _
			)
			
			Return ds
		End Function
		
		
		Public Function GetPublishers() As DataView
			Dim con As SqlConnection = New SqlConnection(ConfigurationSettings.AppSettings("DotNetBooksConString"))
			Dim sda As SqlDataAdapter = New SqlDataAdapter("GetAllPublishers", con)
			sda.SelectCommand.CommandType = CommandType.StoredProcedure
			Dim ds As DataSet = New DataSet()
			sda.Fill(ds, "Publishers")
			Return ds.Tables("Publishers").DefaultView
		End Function
		
		Public Sub UpdateBook( _
			isbn As String, _
			title As String, _
			publisher As String, _
			releaseDate As DateTime, _
			price As String, _
			description As String, _
			amazonLink As String _
		)
			Dim con As SqlConnection = New SqlConnection(ConfigurationSettings.AppSettings("DotNetBooksConString"))
			Dim cmd As SqlCommand = New SqlCommand("UpdateBook", con)
			cmd.CommandType = CommandType.StoredProcedure
			
			cmd.Parameters.Add(New SqlParameter("@isbn", SqlDbType.VarChar,14)).Value = isbn
			cmd.Parameters.Add(New SqlParameter("@title", SqlDbType.VarChar,200)).Value = title
			cmd.Parameters.Add(New SqlParameter("@publisher", SqlDbType.Int)).Value = publisher
			cmd.Parameters.Add(New SqlParameter("@releaseDate", SqlDbType.DateTime)).Value = releaseDate
			cmd.Parameters.Add(New SqlParameter("@price", SqlDbType.Money)).Value = Decimal.Parse(price)
			cmd.Parameters.Add(New SqlParameter("@description", SqlDbType.NText)).Value = description
			cmd.Parameters.Add(New SqlParameter("@amazonLink", SqlDbType.VarChar,255)).Value = amazonLink
			
			con.Open()
			cmd.ExecuteNonQuery()
			con.Close()		
		End Sub
	End Class
End Namespace