Imports System
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls

Namespace DayOfDotNet

	Public Class EditableDataGrid
		Inherits System.Web.UI.Page

		'Map a variable for the DataGrid server control
		Protected BookDataGrid As DataGrid
		'Declare a class-level DataView for editing
		Private _publisherList As DataView
			
		Private Sub Page_Load(sender As object, e As System.EventArgs)
			If Not Page.IsPostBack Then
				'On the first request, Bind the DataGrid
				BindData()
			End If
		End Sub
		
		Private Sub BindData()		
			'When the page is loaded, create the BookDataSet.
			'Create a BooksData class instance, 
			'and invoke GetAllBooks()
			Dim _booksData As BooksData = New BooksData()
			Dim BookDataView As DataView = _booksData.GetAllBooks()
			
			'The BookDataGrid is the first table in the DataSet.
			BookDataGrid.DataSource = BookDataView
			BookDataGrid.DataBind()		
		End Sub
		
		Protected Sub DataGrid_OnEditCommand(sender As Object, e As DataGridCommandEventArgs)
			'Create the _publisherList DataView
			Dim _booksData As BooksData = New BooksData()
			_publisherList = _booksData.GetPublishers()
			
			'Set the EditItemIndex
			CType(sender, DataGrid).EditItemIndex = e.Item.ItemIndex
			BindData()
		End Sub
		
		Protected Sub DataGrid_OnCancelCommand(sender As Object, e As DataGridCommandEventArgs)
			'Turn off editing by reseting the EditItemIndex
			CType(sender, DataGrid).EditItemIndex = -1
			BindData()

		End Sub
		
		Protected Sub DataGrid_OnUpdateCommand(sender As Object, e As DataGridCommandEventArgs)
			'The ISBN is the Text of the second column
			Dim isbn As String= e.Item.Cells(1).Text
			
			'Capture the Title TextBox
			Dim Title As TextBox = CType(e.Item.Cells(2).Controls(0), TextBox)
			
			'Capture the EditItemTemplate controls
			Dim Publisher As DropDownList = CType(e.Item.Cells(3).FindControl("Publishers"), DropDownList)
			Dim ReleaseDate As Calendar= CType(e.Item.Cells(3).FindControl("ReleaseDate"), Calendar)
			Dim Price As TextBox = CType(e.Item.Cells(3).FindControl("Price"), TextBox)
			Dim Description As TextBox = CType(e.Item.Cells(3).FindControl("Description"), TextBox)
			Dim AmazonLink As TextBox = CType(e.Item.Cells(3).FindControl("AmazonLink"), TextBox)
			
			'Update the database with the user values from the server controls
			Dim _booksData As BooksData= New BooksData()
			_booksData.UpdateBook( _
				isbn, _
				Title.Text.Trim(), _
				Publisher.SelectedItem.Value, _
				ReleaseDate.SelectedDate, _
				Price.Text.Trim(), _
				Description.Text.Trim(), _
				AmazonLink.Text.Trim() _
			)
		
			'Turn off editing by reseting the EditItemIndex
			CType(sender, DataGrid).EditItemIndex = -1
			'Retreive the data and bind the grid
			BindData()
		End Sub
		
		Protected Function GetPublisherList() As DataView
			'_publisherList is a class-level DataView
			Return _publisherList
		End Function

		Protected Function GetSelectedPublisher(_publisher As String) As Integer
			'_publisherList is a class-level DataView
			Dim i As Integer = 0
			Do While i < _publisherList.Count
				'Return the selected publisher value
				'when the PublisherName matches
				If _publisherList(i)("Name").ToString() = _publisher Then
					Return i
				End If
				
				i += 1
			Loop
			
			'If there is no match, return 0
			Return 0
		End Function
	End Class
End Namespace