using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// ClubUserDetail   Դϴ.
	/// </summary>
	public class ClubUserDetail : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList datlstUserOpenInfo;
		protected System.Web.UI.WebControls.Label lblName;
		protected System.Web.UI.WebControls.Label lblUserId;
		protected System.Web.UI.WebControls.TextBox txtSelfIntroduction;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("infoSubject", typeof(string)));
			dt.Columns.Add(new DataColumn("infoContent", typeof(string)));

			int clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			string userId = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["userId"], "");

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			SqlDataReader sdr = db.GetClubUserInfo(clubId, userId);
			sdr.Read();
			lblName.Text = sdr["Name"].ToString();
			lblUserId.Text = userId;
			string openInfo = sdr["OpenInformations"].ToString();

			string[] aOpenInfos = ConfigurationSettings.AppSettings["ClubUserOpenInformations"].Split(new char[] {';'});
			string[] aUserOpens = openInfo.Split(new char[] {';'});

			bool userOpened;
			foreach (string opName in aOpenInfos)
			{
				string[] aFieldInfo = opName.Split(new char[] {'='});
				userOpened = false;
				foreach (string openedName in aUserOpens)
					if (openedName == aFieldInfo[0])
						userOpened = true;

				dr = dt.NewRow();
				dr["infoSubject"] = aFieldInfo[0];
				if (userOpened)
				{
					if (aFieldInfo[1].ToLower() == "birthday")
						dr["infoContent"] = Convert.ToDateTime(sdr[aFieldInfo[1]]).ToString("yyyy MM dd");
					else
						dr["infoContent"] = sdr[aFieldInfo[1]];
				}
				else
				{
					dr["infoContent"] = "";
				}
				dt.Rows.Add(dr);
			}
			datlstUserOpenInfo.DataSource = new DataView(dt);
			datlstUserOpenInfo.DataBind();
			txtSelfIntroduction.Text = sdr["SelfIntroduction"].ToString();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
