using System;
using System.IO;
using System.Text;

namespace Chapter08.Ex07
{
	public class HttpFilter : Stream
	{
		private Stream _sink;
		private StreamWriter _sw;
		private long _position;

		public HttpFilter(Stream sink)
		{
			_sink = sink;
			_sw = new StreamWriter(_sink, Encoding.Default);
		}

		public override bool CanRead
		{
			get { return true; }
		}

		public override bool CanSeek
		{
			get { return true; }
		}

		public override bool CanWrite
		{
			get { return true; }
		}

		public override long Length
		{
			//get { return 0; }
			get { return _sink.Length; }
		}

		public override long Position
		{
			get { return _position; }
			set { _position = value; }
		}

		public override long Seek(long offset, System.IO.SeekOrigin direction)
		{
			return _sink.Seek(offset, direction);
		}

		public override void SetLength(long length)
		{
			_sink.SetLength(length);
		}

		public override void Close()
		{
			_sink.Close();
		}

		public override void Flush()
		{
			_sink.Flush();
		}

		public override int Read(byte[] buffer, int offset, int count)
		{
			int readCount = _sink.Read(buffer, offset, count);

			return readCount;
		}

		public override void Write(byte[] buffer, int offset, int count)
		{
			StringBuilder strBuff = new StringBuilder(Encoding.Default.GetString(buffer));
			strBuff.Replace(" ڿ ˴ϴ.", "Response.Filter  ڿ.");

			_sw.Write(strBuff.ToString());
		}
	}
}
