using System;
using System.EnterpriseServices;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace ServicedComponents
{
	[Transaction(TransactionOption.Required)]
	[ObjectPooling(MinPoolSize=1,MaxPoolSize=5)]
	[ClassInterface(ClassInterfaceType.AutoDispatch)]
	[JustInTimeActivation(true)]
	[ConstructionEnabled(Enabled = true, 
		 Default = "Defult Construct String")]
	public class ScDemo1 : ServicedComponent
	{
		public ScDemo1()	
		{
			Trace.WriteLine("Default Object construction");
		}

		protected override void Construct(string constructString) 
		{
			Trace.WriteLine("ScDemo1 : Construct(string constructString)");
		}

		protected override void Activate()
		{
			Trace.WriteLine("ScDemo1 : Activate()");
		}

		protected override void Deactivate()
		{
			Trace.WriteLine("ScDemo1 : Deactivate()");
		}

		protected override bool CanBePooled()
		{
			Trace.WriteLine("ScDemo1 : CanBePooled()");
			return true;
		}


		[AutoComplete]
		public string HelloTest(string userName)
		{
			Trace.WriteLine("ScDemo1 : HelloTest(string userName)");
			string retStr = userName + " ȳϼ?";
			//ContextUtil.DeactivateOnReturn = true;
			return  retStr;
		}
	}
}
