using System;
using System.Collections;
using System.Drawing;
using System.Drawing.Imaging;

namespace Chapter13.Ex04
{
	public class Chap13_Ex04 : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			ArrayList graph1 = new ArrayList();
			ArrayList graph2 = new ArrayList();
			ArrayList graph3 = new ArrayList();
			ArrayList graph4 = new ArrayList();
			ArrayList graphCollection = new ArrayList();

			graph1.Add(10);
			graph1.Add(55);
			graph1.Add(34);
			graph1.Add(67);
			graph1.Add(90);
			graph1.Add(84);

			graph2.Add(68);
			graph2.Add(50);
			graph2.Add(44);
			graph2.Add(40);
			graph2.Add(30);
			graph2.Add(13);

			graph3.Add(63);
			graph3.Add(30);
			graph3.Add(23);
			graph3.Add(46);
			graph3.Add(20);
			graph3.Add(46);

			graph4.Add(2);
			graph4.Add(55);
			graph4.Add(48);
			graph4.Add(67);
			graph4.Add(70);
			graph4.Add(67);

			graphCollection.Add(graph1);
			graphCollection.Add(graph2);
			graphCollection.Add(graph3);
			graphCollection.Add(graph4);

			DrawGraph(graphCollection);
		}

		private void DrawGraph(ArrayList values)
		{
			const int bitmapWidth = 400; //Ʈ  
			const int bitmapHeigth = 400; //Ʈ  
			const int xMax = 6; //x     ְ 
			const int yMax = 100; //y     ְ 
			const int xScale = 1; //x   ϳ Ÿ 
			const int yScale = 10; //y   ϳ Ÿ 
			const int xMargin = 20; //x  
			const int yMargin = 20; //y  

			Bitmap bitmap = new Bitmap(bitmapWidth, bitmapHeigth);
			Graphics graphics = Graphics.FromImage(bitmap);
			graphics.FillRectangle(new SolidBrush(Color.White), 0,0, bitmapWidth, bitmapHeigth);

			Pen axisPen = new Pen(Color.Black, 1);

			graphics.DrawLine(axisPen, xMargin, yMargin, xMargin, bitmapHeigth - yMargin);
			graphics.DrawLine(axisPen, xMargin, bitmapHeigth-yMargin, bitmapWidth-xMargin, bitmapHeigth-yMargin);

			int pixelAmount = (int)(((double)yScale / (double)yMax) * (double)(bitmapHeigth - (yMargin * 2)));
			int currentPos = bitmapHeigth - yMargin - pixelAmount;

			Pen scalePen = new Pen(Color.Coral, 1);
			int count = yMax / yScale;
			for (int i=0; i<count; i++)
			{
				graphics.DrawLine(scalePen, xMargin-2, currentPos, xMargin+2, currentPos);
				currentPos -= pixelAmount;
			}

			pixelAmount = (int)(((double)xScale / (double)(xMax-1)) * (double)(bitmapWidth - (xMargin * 2)));
			currentPos = xMargin + pixelAmount;

			count = (xMax-1) / xScale;
			for (int i=0; i<count; i++)
			{
				graphics.DrawLine(scalePen, currentPos, bitmapHeigth-yMargin-2, currentPos, bitmapHeigth-yMargin+2);
				currentPos += pixelAmount;
			}

			Random random = new Random(1);
			foreach (ArrayList graph in values)
			{
				Pen pen = new Pen(Color.FromArgb(random.Next(0,255),random.Next(0,255),random.Next(0,255)), 2);
				Point[] points = new Point[xMax];

				currentPos = xMargin;
				for (int i=0; i<xMax; i++)
				{
					int yValue = (int)(((double)(int)graph[i]/(double)yMax)*(double)(bitmapHeigth-(yMargin*2)));
					points[i] = new Point(currentPos, bitmapHeigth-yMargin-yValue);
					currentPos += pixelAmount;
				}

				graphics.DrawLines(pen, points);              
			}

			bitmap.Save(Response.OutputStream, ImageFormat.Gif);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
