using System;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;
using System.Configuration;

namespace Chapter16
{
	public class Chapter16_Ex_Collections
	{
		//SQL ؼ
		public void Ex01()
		{
			string strSqlConn = 
				"server=(local);uid=AspDotNet;pwd=xxxx;database=AspDotNetBook";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);

			try 
			{
				sqlConn.Open();

				HttpContext.Current.Response.Write("<h3> !</h3>");
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}

		//OLE DB ؼ
		public void Ex02()
		{
			string strOleDbConn = 
				"Provider=SQLOLEDB;server=(local);uid=AspDotNet;pwd=xxxx;database=AspDotNetBook";
			OleDbConnection oleDbConn = new OleDbConnection(strOleDbConn);

			try 
			{
				oleDbConn.Open();

				HttpContext.Current.Response.Write("<h3> !</h3>");
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> !</h3>");
			}
			finally
			{
				oleDbConn.Close();
			}
		}

		//Ʈ
		public void Ex03(string connStr)
		{
			SqlConnection conn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand();
			SqlTransaction tran;
			
			conn.Open();
			tran = conn.BeginTransaction();

			cmd.Connection = conn;
			cmd.Transaction = tran;
			
			try 
			{
				cmd.CommandText = "insert into tbADO_TUT_1 ";
				cmd.CommandText  += "(integerType, stringType, datetimeType) ";
				cmd.CommandText  += "values(10, 'ڿ 1', '2002-04-20') ";
				cmd.ExecuteNonQuery();

				cmd.CommandText = "insert into tbADO_TUT_2 ";
				cmd.CommandText  += "(integerType, stringType) ";
				cmd.CommandText  += "values(10, 'ڿ 1') ";
				cmd.ExecuteNonQuery();

				tran.Commit();
				HttpContext.Current.Response.Write("<h3> !</h3>");
			}
			catch (Exception err) 
			{
				string s = err.Message;
				tran.Rollback();
				HttpContext.Current.Response.Write("<h3> !</h3>");
				HttpContext.Current.Response.Write(s + "<br>");
			}
			finally
			{
				conn.Close();
			}
		}

		//ExecuteReader
		public void Ex04(string connStr)
		{
			string strSqlConn = 
				ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select stringType from tbADO_TUT_1";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			try 
			{
				SqlDataReader dr = cmdSql.ExecuteReader();
				while (dr.Read())
				{
					string strData = dr["stringType"].ToString();
					HttpContext.Current.Response.Write(strData + "<br>");
				}
				dr.Close();
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}

		//ExecuteScalar
		public void Ex05(string connStr)
		{
			string strSqlConn = 
				ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select count(*) from tbADO_TUT_1";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			try 
			{
				int recCount = (int)cmdSql.ExecuteScalar();
				string strRecCount = "  : " + recCount;
				HttpContext.Current.Response.Write("<h3>" + strRecCount + "</h3>");
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}

		//ExecuteNoneQuery
		public void Ex06(string connStr)
		{
			string strQuery = "insert into tbADO_TUT_1 ";
			strQuery += "(integerType, stringType, datetimeType) ";
			strQuery += "values(20, 'ExecuteNoneQuery ', '"+ DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") +"') ";

			SqlConnection conn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand(strQuery, conn);

			conn.Open();
			try 
			{
				int effectedCount = cmd.ExecuteNonQuery();
				HttpContext.Current.Response.Write("<h3>   : " + effectedCount + "</h3>");
			}
			catch (Exception err)
			{
				HttpContext.Current.Response.Write("<h3>Insert !</h3>");
			}
			finally
			{
				conn.Close();
			}
		}

		/*
		public void Ex06(string connStr)
		{
			string strQuery = "insert into tbADO_TUT_1 ";
			strQuery += "(integerType, stringType, datetimeType) ";
			strQuery += "values(20, @stringType, @datetimeType) ";

			SqlConnection conn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand(strQuery, conn);

			cmd.Parameters.Add("@stringType", SqlDbType.VarChar, 50).Value = "ExecuteNoneQuery's ";
			cmd.Parameters.Add("@datetimeType", SqlDbType.DateTime).Value = DateTime.Now;

			conn.Open();
			try 
			{
				int effectedCount = cmd.ExecuteNonQuery();
				HttpContext.Current.Response.Write("<h3>   : " + effectedCount + "</h3>");
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3>Insert !</h3>");
			}
			finally
			{
				conn.Close();
			}
		}
		*/

		// ν - SQL
		public void Ex07(string connStr)
		{
			SqlConnection conn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand("AdoTutSimpleSelect", conn);

			cmd.CommandType = CommandType.StoredProcedure;
			conn.Open();
			try 
			{
				SqlDataReader dr = cmd.ExecuteReader();
				while (dr.Read())
				{
					string strData = dr["stringType"].ToString();
					HttpContext.Current.Response.Write(strData + "<br>");
				}
				dr.Close();
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3>б !</h3>");
			}
			finally
			{
				conn.Close();
			}
		}

		//CommandType.TableDirect - OLE DB 
		public OleDbDataReader Ex08(string connStr)
		{
			OleDbConnection conn = new OleDbConnection(connStr);
			OleDbCommand cmd = new OleDbCommand("tbADO_TUT_1", conn);

			cmd.CommandType = CommandType.TableDirect;
			conn.Open();
			OleDbDataReader dr = null;
			try 
			{
				dr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3>б !</h3>");
			}
			return dr;
		}

		//Ķ͸   - 1
		public void Ex09(string connStr)
		{
			string strQuery = "insert into tbADO_TUT_1 ";
			strQuery += "(integerType, stringType, datetimeType) ";
			strQuery += "values(9, 'Ķ ׽Ʈ 1 - o''clock', '" + 
				DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "') ";

			SqlConnection conn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand(strQuery, conn);

			conn.Open();
			cmd.ExecuteNonQuery();
			conn.Close();
		}

		//Ķ͸   - 2
		public void Ex10(string connStr)
		{
			string strQuery = "insert into tbADO_TUT_1 ";
			strQuery += "(integerType, stringType, datetimeType) ";
			strQuery += "values(@integerType, @stringType, @datetimeType) ";

			SqlConnection conn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand(strQuery, conn);

			cmd.Parameters.Add("@integerType", SqlDbType.Int).Value = 10;
			cmd.Parameters.Add("@stringType", SqlDbType.VarChar, 50).Value = "Ķ ׽Ʈ 2 - o'clock";
			cmd.Parameters.Add("@datetimeType", SqlDbType.DateTime).Value = DateTime.Now;

			conn.Open();
			cmd.ExecuteNonQuery();
			conn.Close();
		}

		/*
		//Ķ͸   - 3
		public void Ex11(string connStr)
		{
			string strQuery = "select integerType, stringType ";
			strQuery +=	"from tbADO_TUT_1 ";
			strQuery +=	"where integerType >= @min and integerType <= @max";

			SqlConnection sqlConn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand(strQuery, sqlConn);

			
			//SqlParameter parmMin = new SqlParameter("@min", SqlDbType.Int);
			//parmMin.Value = 3;
			//cmd.Parameters.Add(parmMin);
			
			//cmd.Parameters.Add(new SqlParameter("@min", SqlDbType.Int)).Value = 3;
			cmd.Parameters.Add("@min", SqlDbType.Int).Value = 3;

			//SqlParameter parmMax = new SqlParameter("@max", SqlDbType.Int);
			//parmMax.Value = 6;
			//cmd.Parameters.Add(parmMax);

			//cmd.Parameters.Add(new SqlParameter("@max", SqlDbType.Int)).Value = 6;
			cmd.Parameters.Add("@max", SqlDbType.Int).Value = 6;

			sqlConn.Open();
			try 
			{
				string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
				SqlDataReader dr = cmd.ExecuteReader();
				while (dr.Read())
				{
					string strData = dr["integerType"] + nbsp;
					strData += dr["stringType"];

					HttpContext.Current.Response.Write(strData + "<br>");
				}
			}
			catch (Exception err)
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}
		*/

		//Ķ͸   - 3 - OLD DB
		public void Ex11(string connStr)
		{
			string strQuery = "select integerType, stringType ";
			strQuery +=	"from tbADO_TUT_1 ";
			strQuery +=	"where integerType >= ? and integerType <= ?";

			OleDbConnection oleDbConn = new OleDbConnection(connStr);
			OleDbCommand cmd = new OleDbCommand(strQuery, oleDbConn);

			cmd.Parameters.Add("@min", SqlDbType.Int).Value = 3;
			cmd.Parameters.Add("@max", SqlDbType.Int).Value = 6;

			oleDbConn.Open();
			try 
			{
				string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
				OleDbDataReader dr = cmd.ExecuteReader();
				while (dr.Read())
				{
					string strData = dr["integerType"] + nbsp;
					strData += dr["stringType"];

					HttpContext.Current.Response.Write(strData + "<br>");
				}
			}
			catch (Exception err)
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			finally
			{
				oleDbConn.Close();
			}
		}

		//Ķ͸   - 4
		public void Ex12(string connStr)
		{
			SqlConnection sqlConn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand("Get_ADO_TUT_2_ByOUTPUT", sqlConn);

			cmd.CommandType = CommandType.StoredProcedure;

			cmd.Parameters.Add("@integerType", SqlDbType.Int).Value = 3;

			cmd.Parameters.Add("@stringType", SqlDbType.VarChar, 50);
			cmd.Parameters["@stringType"].Direction = ParameterDirection.Output;

			sqlConn.Open();
			try 
			{
				cmd.ExecuteNonQuery();
				string outVar = cmd.Parameters["@stringType"].Value.ToString();
				HttpContext.Current.Response.Write("<h3>OUTPUT  : "+ outVar +"</h3>");
			}
			catch (Exception err)
			{
				HttpContext.Current.Response.Write("<h3> ν !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}

		//Ķ͸   - 5
		public void Ex13(string connStr)
		{
			SqlConnection sqlConn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand("Add_ADO_TUT_2", sqlConn);

			cmd.CommandType = CommandType.StoredProcedure;

			cmd.Parameters.Add("@integerType", SqlDbType.Int).Value = 30;
			cmd.Parameters.Add("@stringType", SqlDbType.VarChar, 50).Value = "Ķ RETURN";

			cmd.Parameters.Add("RETURN_VALUE", SqlDbType.Int);
			cmd.Parameters["RETURN_VALUE"].Direction = ParameterDirection.ReturnValue;

			sqlConn.Open();
			try 
			{
				cmd.ExecuteNonQuery();

				int retVar = (int)cmd.Parameters["RETURN_VALUE"].Value;
				HttpContext.Current.Response.Write("<h3>ReturnValue  : "+ retVar +"</h3>");
			}
			catch (Exception err)
			{
				HttpContext.Current.Response.Write("<h3> ν !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}

		//CommandBehavior - CloseConnection
		public SqlDataReader Ex14(string connStr)
		{
			string strSqlConn = connStr;
			string strQuery = "select * from tbADO_TUT_1";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;
			try 
			{
				dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}

			return dr;
		}

		//SchemaOnly - GetSchemaTable
		public void Ex15(string connStr)
		{
			string strQuery = "select * from tbADO_TUT_2";
			SqlConnection sqlConn = new SqlConnection(connStr);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			try 
			{
				SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.SchemaOnly);

				DataTable schemaTable = dr.GetSchemaTable();
				foreach (DataRow row in schemaTable.Rows)
				{
					foreach (DataColumn col in schemaTable.Columns)
						HttpContext.Current.Response.Write(col.ColumnName + " = " + row[col] + "<br>");
					HttpContext.Current.Response.Write("<br>");
				}
				dr.Close();
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3>Ű б !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}

		/*
		//SqlDataReader - GetName
		public void Ex16(string connStr)
		{
			string strQuery = "select integerType, stringType " + 
								"from tbADO_TUT_1";
			SqlConnection sqlConn = new SqlConnection(connStr);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			try 
			{
				SqlDataReader dr = cmdSql.ExecuteReader();
				string strFiledName = String.Empty;
				for (int i=0; i<dr.FieldCount; i++)
				{
					strFiledName += dr.GetName(i) + "&nbsp;&nbsp;";
				}
				HttpContext.Current.Response.Write(strFiledName + "<hr>");

				string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
				nbsp += nbsp + nbsp + nbsp;
				while (dr.Read())
				{
					string strData = dr.GetInt32(0).ToString() + nbsp;
					strData += dr["stringType"] + nbsp;

					HttpContext.Current.Response.Write(strData + "<br>");
				}
				dr.Close();
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}
		*/


		//SqlDataReader - NextResult
		public void Ex16(string connStr)
		{
			string strSqlConn = connStr;
			string strQuery = "select * from tbADO_TUT_1;" +
								"select * from tbADO_TUT_2;";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			try 
			{
				SqlDataReader dr = cmdSql.ExecuteReader();
				//SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.SingleResult);
				do 
				{
					string strFiledName = String.Empty;
					for (int i=0; i<dr.FieldCount; i++)
					{
						strFiledName += dr.GetName(i) + "&nbsp;&nbsp;";
					}
					HttpContext.Current.Response.Write(strFiledName + "<hr>");

					string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
					nbsp += nbsp + nbsp + nbsp;
					while (dr.Read())
					{
						string strData = dr.GetInt32(0).ToString() + nbsp;
						strData += dr["stringType"] + nbsp;

						HttpContext.Current.Response.Write(strData + "<br>");
					}

					HttpContext.Current.Response.Write("<br><br>");
				} while (dr.NextResult());
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			finally
			{
				sqlConn.Close();
			}
		}

		//̽ ̿  ޼ҵ
		public void Ex17(IDbConnection conn, string subject)
		{
			string strQuery = "select integerType, stringType " + 
				"from tbADO_TUT_1";
			IDbCommand cmd = conn.CreateCommand();
			cmd.Connection = conn;
			cmd.CommandText = strQuery;

			HttpContext.Current.Response.Write("<h3>" + subject + "</h3>");
			conn.Open();
			try 
			{
				IDataReader dr = cmd.ExecuteReader();
				string strFiledName = String.Empty;
				for (int i=0; i<dr.FieldCount; i++)
				{
					strFiledName += dr.GetName(i) + "&nbsp;&nbsp;";
				}
				HttpContext.Current.Response.Write(strFiledName + "<hr>");

				string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
				nbsp += nbsp + nbsp + nbsp;
				while (dr.Read())
				{
					string strData = dr.GetInt32(0).ToString() + nbsp;
					strData += dr["stringType"] + nbsp;

					HttpContext.Current.Response.Write(strData + "<br>");
				}
				dr.Close();
				HttpContext.Current.Response.Write("<br><br>");
			}
			catch
			{
				HttpContext.Current.Response.Write("<h3> б !</h3>");
			}
			finally
			{
				conn.Close();
			}
		}
	}
}
