using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter17.Ex03
{
	public class Chap17_Ex03 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.DataGrid DataGrid3;
		protected System.Web.UI.WebControls.DataGrid DataGrid2;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DataSet ds = GetDsParentChild();

				DataGrid1.DataSource = ds;
				DataGrid1.DataMember = "Parent";
				DataGrid1.DataBind();

				DataGrid2.DataSource = ds;
				DataGrid2.DataMember = "Child";
				DataGrid2.DataBind();
			}
		}

		private DataSet GetDsParentChild()
		{
			SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daParent = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);

			DataSet ds = new DataSet();
			daParent.FillSchema(ds, SchemaType.Source, "Parent");
			daParent.Fill(ds, "Parent");
			daChild.FillSchema(ds, SchemaType.Source, "Child");
			daChild.Fill(ds, "Child");

			ds.Relations.Add("ParentChildRelation", 
				ds.Tables["Parent"].Columns["id"], 
				ds.Tables["Child"].Columns["parentId"]);

			return ds;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.SelectedIndexChanged += new System.EventHandler(this.DataGrid1_SelectedIndexChanged);
			this.DataGrid2.SelectedIndexChanged += new System.EventHandler(this.DataGrid2_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DataGrid1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataSet ds = GetDsParentChild();
			DataGrid dataGrid = (DataGrid)sender;
			//õ  DataGridItem ü ´.
			DataGridItem dgItem = dataGrid.Items[dataGrid.SelectedIndex];

			//õ  id ´
			int id = int.Parse(dgItem.Cells[1].Text);
			DataRow parentRow = (ds.Tables["Parent"].Select("id=" + id))[0];
			//DataRow parentRow = ds.Tables["Parent"].Rows.Find(id);
			DataRow[] childRows = parentRow.GetChildRows("ParentChildRelation");

			DataTable dtChild = ds.Tables["Child"].Clone();
			foreach (DataRow dr in childRows)
			{
				dtChild.ImportRow(dr);
			}
			DataGrid3.DataSource = dtChild.DefaultView;
			DataGrid3.DataBind();
		}

		private void DataGrid2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataSet ds = GetDsParentChild();
			DataGrid dataGrid = (DataGrid)sender;
			//õ  DataGridItem ü ´.
			DataGridItem dgItem = dataGrid.Items[dataGrid.SelectedIndex];

			//õ  id ´
			int id = int.Parse(dgItem.Cells[1].Text);
			DataRow childRow = (ds.Tables["Child"].Select("id=" + id))[0];
			//DataRow childRow = ds.Tables["Child"].Rows.Find(id);
			DataRow parentRow = childRow.GetParentRow("ParentChildRelation");

			DataTable dtParent = ds.Tables["Parent"].Clone();
			dtParent.ImportRow(parentRow);

			DataGrid3.DataSource = dtParent.DefaultView;
			DataGrid3.DataBind();
		}
	}
}
