using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter17.Ex07
{
	public class Chap17_Ex07 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.DataGrid DataGrid2;
		protected System.Web.UI.WebControls.TextBox txtNewValue;
		protected System.Web.UI.WebControls.Button btnInsert;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DataGrid1.DataSource = GetDsParentChild();
				DataGrid1.DataMember = "Parent";
				DataGrid1.DataBind();
			}
		}

		private DataSet GetDsParentChild()
		{
			SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daParent = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);

			DataSet ds = new DataSet();
			daParent.FillSchema(ds, SchemaType.Source, "Parent");
			daParent.Fill(ds, "Parent");
			daChild.FillSchema(ds, SchemaType.Source, "Child");
			daChild.Fill(ds, "Child");

			ds.Relations.Add("ParentChildRelation", 
				ds.Tables["Parent"].Columns["id"], 
				ds.Tables["Child"].Columns["parentId"]);

			return ds;
		}

		//Parent õ  id ´
		private int GetSelectedParentID()
		{
			//õ  DataGridItem ü ´.
			DataGridItem dgItem = DataGrid1.Items[DataGrid1.SelectedIndex];

			return int.Parse(dgItem.Cells[1].Text);
		}

		private void BindChild(DataSet ds)
		{
			int id = GetSelectedParentID();

			//DataRow parentRow = (ds.Tables["Parent"].Select("id=" + id))[0];
			DataRow parentRow = ds.Tables["Parent"].Rows.Find(id);

			DataRow[] childRows = parentRow.GetChildRows("ParentChildRelation");

			DataTable dtChild = ds.Tables["Child"].Clone();
			foreach (DataRow dr in childRows)
			{
				dtChild.ImportRow(dr);
			}
			DataGrid2.DataSource = dtChild.DefaultView;
			DataGrid2.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.SelectedIndexChanged += new System.EventHandler(this.DataGrid1_SelectedIndexChanged);
			this.DataGrid2.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_CancelCommand);
			this.DataGrid2.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_EditCommand);
			this.DataGrid2.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_UpdateCommand);
			this.DataGrid2.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_DeleteCommand);
			this.btnInsert.Click += new System.EventHandler(this.btnInsert_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DataGrid1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataSet ds = GetDsParentChild();
			BindChild(ds);
		}

		private void DataGrid2_DeleteCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			SqlConnection conn = new SqlConnection(
				ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);
			SqlCommandBuilder cmdBuider = new SqlCommandBuilder(daChild);

			DataSet ds = GetDsParentChild();

			//Ϸ  id  ´.
			string id = e.Item.Cells[2].Text;
			//DataRow row = (ds.Tables["Child"].Select("id=" + id))[0];
			DataRow row = ds.Tables["Child"].Rows.Find(id);
			row.Delete();

			daChild.Update(ds, "Child");

			BindChild(ds);
		}

		private void DataGrid2_EditCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = e.Item.ItemIndex;

			DataSet ds = GetDsParentChild();
			BindChild(ds);
		}

		private void DataGrid2_UpdateCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			SqlConnection conn = new SqlConnection(
				ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);
			SqlCommandBuilder cmdBuider = new SqlCommandBuilder(daChild);

			DataSet ds = GetDsParentChild();

			//Ϸ  id  ´.
			string id = e.Item.Cells[2].Text;
			//DataRow row = (ds.Tables["Child"].Select("id=" + id))[0];
			DataRow row = ds.Tables["Child"].Rows.Find(id);

			TextBox txtStringValue = (TextBox)e.Item.Cells[4].Controls[0];
			row.BeginEdit();
			row["stringValue"] = txtStringValue.Text;
			row.EndEdit();

			daChild.Update(ds, "Child");

			((DataGrid)source).EditItemIndex = -1;

			BindChild(ds);
		}

		private void DataGrid2_CancelCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = -1;

			DataSet ds = GetDsParentChild();
			BindChild(ds);		
		}

		private void btnInsert_Click(object sender, System.EventArgs e)
		{
			SqlConnection conn = new SqlConnection(
				ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);
			SqlCommandBuilder cmdBuider = new SqlCommandBuilder(daChild);

			DataSet ds = GetDsParentChild();

			int parentRowIdx = GetSelectedParentID();
			ds.Tables["Child"].Rows.Add(
				new object[] {null, parentRowIdx, txtNewValue.Text});

			daChild.Update(ds, "Child");

			BindChild(ds);
		}
	}
}
