using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter17.Ex08
{
	public class Chap17_Ex08 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.DataGrid DataGrid2;
		protected System.Web.UI.WebControls.TextBox txtNewValue;
		protected System.Web.UI.WebControls.Button btnInsert;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DataGrid1.DataSource = GetDsParentChild();
				DataGrid1.DataMember = "Parent";
				DataGrid1.DataBind();
			}
		}

		private ParentChildDS GetDsParentChild()
		{
			SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daParent = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);

			//DataSet ds = new DataSet();
			ParentChildDS ds = new ParentChildDS();
			daParent.FillSchema(ds, SchemaType.Source, "Parent");
			daParent.Fill(ds, "Parent");
			daChild.FillSchema(ds, SchemaType.Source, "Child");
			daChild.Fill(ds, "Child");

			//Typed DataSet ȿ 谡 Ե Ƿ ʿ.
			//ds.Relations.Add("ParentChildRelation", 
			//	ds.Tables["Parent"].Columns["id"], 
			//	ds.Tables["Child"].Columns["parentId"]);

			return ds;
		}

		//Parent õ  id ´
		private int GetSelectedParentID()
		{
			//õ  DataGridItem ü ´.
			DataGridItem dgItem = DataGrid1.Items[DataGrid1.SelectedIndex];

			return int.Parse(dgItem.Cells[1].Text);
		}

		private void BindChild(ParentChildDS ds)
		{
			int id = GetSelectedParentID();

			//DataRow parentRow = ds.Tables["Parent"].Rows.Find(id);
			ParentChildDS.ParentRow parentRow = ds.Parent.FindByid(id);

			//DataRow[] childRows = parentRow.GetChildRows("ParentChildRelation");
			ParentChildDS.ChildRow[] childRows = parentRow.GetChildRows();

			//DataTable dtChild = ds.Tables["Child"].Clone();
			DataTable dtChild = ds.Child.Clone();
			//foreach (DataRow dr in childRows)
			foreach (ParentChildDS.ChildRow dr in childRows)
			{
				dtChild.ImportRow(dr);
			}
			DataGrid2.DataSource = dtChild.DefaultView;
			DataGrid2.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.SelectedIndexChanged += new System.EventHandler(this.DataGrid1_SelectedIndexChanged);
			this.DataGrid2.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_CancelCommand);
			this.DataGrid2.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_EditCommand);
			this.DataGrid2.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_UpdateCommand);
			this.DataGrid2.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_DeleteCommand);
			this.btnInsert.Click += new System.EventHandler(this.btnInsert_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void DataGrid1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//DataSet ds = new DataSet();
			ParentChildDS ds = GetDsParentChild();
			BindChild(ds);
		}

		private void DataGrid2_DeleteCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			SqlConnection conn = new SqlConnection(
				ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);
			SqlCommandBuilder cmdBuider = new SqlCommandBuilder(daChild);

			//DataSet ds = new DataSet();
			ParentChildDS ds = GetDsParentChild();

			//Ϸ  id  ´.
			int id = int.Parse(e.Item.Cells[2].Text);
			//DataRow row = ds.Tables["Child"].Rows.Find(id);
			ParentChildDS.ChildRow row = ds.Child.FindByid(id);
			row.Delete();

			daChild.Update(ds, "Child");

			BindChild(ds);
		}

		private void DataGrid2_EditCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = e.Item.ItemIndex;

			//DataSet ds = new DataSet();
			ParentChildDS ds = GetDsParentChild();
			BindChild(ds);
		}

		private void DataGrid2_UpdateCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			SqlConnection conn = new SqlConnection(
				ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);
			SqlCommandBuilder cmdBuider = new SqlCommandBuilder(daChild);

			//DataSet ds = new DataSet();
			ParentChildDS ds = GetDsParentChild();

			//Ϸ  id  ´.
			int id = int.Parse(e.Item.Cells[2].Text);
			//DataRow row = ds.Tables["Child"].Rows.Find(id);
			ParentChildDS.ChildRow row = ds.Child.FindByid(id);

			TextBox txtStringValue = (TextBox)e.Item.Cells[4].Controls[0];
			row.BeginEdit();
			//row["stringValue"] = txtStringValue.Text;
			row.stringValue = txtStringValue.Text;
			row.EndEdit();

			daChild.Update(ds, "Child");

			((DataGrid)source).EditItemIndex = -1;

			BindChild(ds);
		}

		private void DataGrid2_CancelCommand(object source, 
			System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = -1;

			//DataSet ds = new DataSet();
			ParentChildDS ds = GetDsParentChild();
			BindChild(ds);		
		}

		private void btnInsert_Click(object sender, System.EventArgs e)
		{
			SqlConnection conn = new SqlConnection(
				ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter daChild = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_CHILD", conn);
			SqlCommandBuilder cmdBuider = new SqlCommandBuilder(daChild);

			//DataSet ds = new DataSet();
			ParentChildDS ds = GetDsParentChild();

			int parentRowId = GetSelectedParentID();

			//ds.Tables["Child"].Rows.Add(
			//	new object[] {null, parentRowIdx, txtNewValue.Text});
			ParentChildDS.ChildRow cRow = ds.Child.NewChildRow();
			cRow.parentId = parentRowId;
			cRow.stringValue = txtNewValue.Text;
			ds.Child.AddChildRow(cRow);
			//Ǵ
			//ds.Child.AddChildRow(ds.Parent.FindByid(parentRowId), txtNewValue.Text);

			daChild.Update(ds, "Child");

			BindChild(ds);
		}
	}
}
