using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter18.Ex02
{
	public class Chap18_Ex02 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnWithSchema;
		protected System.Web.UI.WebControls.Button btnNonSchema;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
		}

		private void DisplaySchema(DataSet ds)
		{
			foreach (DataColumn dc in ds.Tables["Parent"].PrimaryKey)
				Response.Write("PrimaryKey = " + dc.ColumnName + "<br>");

			foreach (DataColumn dc in ds.Tables["Parent"].Columns)
			{
				Response.Write("<br>");
				Response.Write("ColumnName = " + dc.ColumnName + "<br>");
				Response.Write("DataType = " + dc.DataType + "<br>");
				Response.Write("MaxLength = " + dc.MaxLength + "<br>");
				Response.Write("AutoIncrement = " + dc.AutoIncrement + "<br>");
				Response.Write("AutoIncrementStep = " + dc.AutoIncrementStep + "<br>");
				Response.Write("AllowDBNull = " + dc.AllowDBNull + "<br>");
				Response.Write("Unique = " + dc.Unique + "<br>");
			}	
		}

		//DataSet    ä
		private DataSet GetDataSetWithSchema()
		{
			SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);

			DataSet ds = new DataSet();
			//da.FillSchema(ds, SchemaType.Source, "Parent");
			da.MissingSchemaAction = MissingSchemaAction.AddWithKey;
			da.Fill(ds, "Parent");

			return ds;
		}

		//DataSet   ä
		private DataSet GetDataSetNonSchema()
		{
			SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);

			DataSet ds = new DataSet();
			da.Fill(ds, "Parent");

			return ds;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.btnWithSchema.Click += new System.EventHandler(this.btnWithSchema_Click);
			this.btnNonSchema.Click += new System.EventHandler(this.btnNonSchema_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void btnWithSchema_Click(object sender, System.EventArgs e)
		{
			DataSet ds = GetDataSetWithSchema();

			Response.Write("ͺ̽ Ű  :<br><br>");
			DisplaySchema(ds);
		}

		private void btnNonSchema_Click(object sender, System.EventArgs e)
		{
			DataSet ds = GetDataSetNonSchema();

			Response.Write("ͺ̽ Ű   :<br>");
			DisplaySchema(ds);

			DataColumnCollection dcCollection = ds.Tables["Parent"].Columns;

			ds.Tables["Parent"].PrimaryKey = new DataColumn[] {dcCollection["id"]};

			dcCollection["id"].AllowDBNull = false;
			dcCollection["id"].AutoIncrement = true;
			dcCollection["id"].AutoIncrementStep = 1;
			dcCollection["stringValue"].MaxLength = 50;

			Response.Write("<hr>");
			Response.Write("<br>Ӽ ̿ Ű   :<br><br>");

			DisplaySchema(ds);
		}
	}
}
