using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter20.Ex04
{
	public class Chap20_Ex04 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.RadioButtonList RadioButtonList1;
	
		const int rowCount = 5;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DataGrid1.PageSize = rowCount;
				BindGrid(1);
			}
		}

		private void BindGrid(int pageIndex)
		{
			DataGrid1.VirtualItemCount = GetRecordCount();
			DataGrid1.DataSource = CreateDataSource(pageIndex);
			DataGrid1.DataBind();
		}

		private SqlDataReader CreateDataSource(int pageIndex) 
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand("GetPagePortionInOrders", sqlConn);

			cmdSql.CommandType = CommandType.StoredProcedure;

			cmdSql.Parameters.Add(new SqlParameter("@PAGE", SqlDbType.Int, 4));
			cmdSql.Parameters["@PAGE"].Value = pageIndex;

			cmdSql.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4));
			cmdSql.Parameters["@ROW_COUNT"].Value = rowCount;

			sqlConn.Open();
			SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		private int GetRecordCount()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select count(*) from tbDataPresentation2_Orders";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			int recCount = (int)cmdSql.ExecuteScalar();
			sqlConn.Close();

			return recCount;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_ItemCommand);
			this.DataGrid1.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.DataGrid1_PageIndexChanged);
			this.RadioButtonList1.SelectedIndexChanged += new System.EventHandler(this.RadioButtonList1_SelectedIndexChanged);
			this.ID = "Chap20_Ex04";
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DataGrid1_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			DataGrid1.CurrentPageIndex = e.NewPageIndex;
			BindGrid(e.NewPageIndex + 1);
		}

		private void RadioButtonList1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (RadioButtonList1.SelectedItem.Value == "1")
				DataGrid1.PagerStyle.Mode = PagerMode.NextPrev;
			else
				DataGrid1.PagerStyle.Mode = PagerMode.NumericPages;

			BindGrid(DataGrid1.CurrentPageIndex + 1);
		}

		private void DataGrid1_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			Response.Write("CommandName : " + e.CommandName + 
				"<br>" + "CommandArgument : " + e.CommandArgument);
		}
	}
}
