using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;

namespace CustomControls.Start
{
	public class ControlStart3 : Control
	{
		private string text;
		private bool fontBold;
		private bool fontItlic;
		private FontSize fontSize;
		private Color fontColor;
	
		public string Text 
		{
			get	{return text;}
			set	{text = value;}
		}

		public bool FontBold
		{
			get	{return fontBold;}
			set	{fontBold = value;}
		}

		public bool FontItlic
		{
			get	{return fontItlic;}
			set	{fontItlic = value;}
		}

		public FontSize FontSize
		{
			get	{return fontSize;}
			set	{fontSize = value;}
		}

		public Color FontColor
		{
			get	{return fontColor;}
			set	{fontColor = value;}
		}

		protected override void Render(System.Web.UI.HtmlTextWriter writer)
		{
			if (fontBold)
				writer.AddStyleAttribute(HtmlTextWriterStyle.FontWeight, "bold");
			if (fontItlic)
				writer.AddStyleAttribute(HtmlTextWriterStyle.FontStyle, "italic");
			if (fontSize != FontSize.NotSet)
				writer.AddStyleAttribute(HtmlTextWriterStyle.FontSize, fontSize.ToString());
			if (!fontColor.IsEmpty)
				writer.AddStyleAttribute(HtmlTextWriterStyle.BackgroundColor, ColorTranslator.ToHtml(fontColor));

			writer.RenderBeginTag(HtmlTextWriterTag.Span);
			writer.Write(text);
			writer.RenderEndTag();
		}
	}
}
