using System;
using System.IO;
using System.Web;
using System.Web.UI;

namespace CustomControls.Start
{
	public class ViewLifeCycle : Control, IPostBackDataHandler, IPostBackEventHandler
	{
		enum OutPutMode {ControlCreate, General};

		public ViewLifeCycle()
		{
			WriteToFile("Ʈ ", "ViewLifeCycle", OutPutMode.ControlCreate);
		}

		protected override void OnInit(System.EventArgs e)
		{
			WriteToFile("Init", "OnInit", OutPutMode.General);
		}

		protected override void LoadViewState(object savedState)
		{
			WriteToFile("ViewState ", "LoadViewState", OutPutMode.General);
		}

		public bool LoadPostData(string postDataKey, System.Collections.Specialized.NameValueCollection postCollection)
		{
			WriteToFile("Ʈ  ó", "LoadPostData", OutPutMode.General);

			return true;
		}

		protected override void OnLoad(System.EventArgs e)
		{
			WriteToFile("Load", "OnLoad", OutPutMode.General);		
		}

		public void RaisePostDataChangedEvent()
		{
			WriteToFile("  ̺Ʈ ߻", "RaisePostDataChangedEvent", OutPutMode.General);
		}

		public void RaisePostBackEvent(string eventArgument)
		{
			WriteToFile("Ʈ ̺Ʈ ߻", "RaisePostBackEvent", OutPutMode.General);
		}

		protected override void OnPreRender(System.EventArgs e)
		{
			WriteToFile("PreRender", "OnPreRender", OutPutMode.General);
		}

		protected override object SaveViewState()
		{
			WriteToFile("ViewState ", "SaveViewState", OutPutMode.General);
			//⼭  null ȯϸ Ʈ ɶ 
			//LoadViewState ޼ҵ尡 ȣ ʴ´.
			return new object();
		}

		protected override void Render(System.Web.UI.HtmlTextWriter writer)
		{
			writer.AddAttribute(HtmlTextWriterAttribute.Name, this.UniqueID);
			writer.AddAttribute(HtmlTextWriterAttribute.Type,"text");
			writer.RenderBeginTag(HtmlTextWriterTag.Input);
			writer.RenderEndTag();

			writer.AddAttribute(HtmlTextWriterAttribute.Onclick, Page.GetPostBackEventReference(this, ""));
			writer.AddAttribute(HtmlTextWriterAttribute.Type,"button");
			writer.AddAttribute(HtmlTextWriterAttribute.Value,"Post Back");
			writer.RenderBeginTag(HtmlTextWriterTag.Input);
			writer.RenderEndTag();

			base.Render(writer);
			WriteToFile("", "RenderContents", OutPutMode.General);
		}

		protected override void OnUnload(System.EventArgs e)
		{
			WriteToFile("Unload", "OnUnload", OutPutMode.General);
		}

		private void WriteToFile(string step, string method, OutPutMode outPutMode)
		{
			//Ÿӿ Ϸ ϵ
			if (HttpContext.Current == null)
				return;

			string logFile = "C:\\Chap21_ControlLifeCycle.log";
        
			FileStream fs = new FileStream(logFile,
				FileMode.Append, FileAccess.Write);

			StreamWriter sw = new StreamWriter(fs, 
				System.Text.Encoding.Default);
			if (outPutMode == OutPutMode.ControlCreate)
			{
				sw.WriteLine();
				sw.WriteLine();
				sw.WriteLine("Ʈ ó " + "\t" + DateTime.Now.ToString() + " :");
				sw.Write("\t" + step);
				sw.WriteLine("\t- " + method + " ޼ҵ");
			}
			else if (outPutMode == OutPutMode.General)
			{
				sw.Write("\t" + step);
				sw.WriteLine("\t- " + method + " ޼ҵ");
			}

			sw.Close();
		}
	}
}
