using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Button
{
	[DefaultProperty("Text"), 
	ToolboxData("<{0}:SimpleButton runat=server></{0}:SimpleButton>")]
	public class SimpleButton : WebControl, IPostBackEventHandler
	{
		public event CommandEventHandler Command;
		public event EventHandler Click;

		#region Ӽ
		[Bindable(true), 
		Category("Appearance"), 
		DefaultValue("")] 
		public string Text {
			get	{
				object o = ViewState["text"];
				return (o == null) ? String.Empty : (string)o;
			}
			set	{ViewState["text"] = value;}
		}

		[Bindable(true), 
		Category("Behavior"), 
		DefaultValue("")] 
		public string CommandName {
			get	{
				object o = ViewState["commandName"];
				return (o == null) ? String.Empty : (string)o;
			}
			set	{ViewState["commandName"] = value;}
		}

		[Bindable(true), 
		Category("Behavior"), 
		DefaultValue("")] 
		public string CommandArgument {
			get	{
				object o = ViewState["CommandArgument"];
				return (o == null) ? String.Empty : (string)o;
			}
			set	{ViewState["CommandArgument"] = value;}
		}

		[Category("Behavior"), 
		DefaultValue(true)] 
		public bool CausesValidation {
			get{
				object o = ViewState["CausesValidation"];
				return (o == null) ? true : (bool)o;
			} 
			set{ViewState["CausesValidation"] = value;}
		}
		#endregion
		#region ޼ҵ

		public SimpleButton() : base(HtmlTextWriterTag.Input) {}

		protected override void AddAttributesToRender(HtmlTextWriter writer)
		{
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);
			writer.AddAttribute(HtmlTextWriterAttribute.Type, "submit");
			writer.AddAttribute(HtmlTextWriterAttribute.Value, Text);
			if (CausesValidation) {
				writer.AddAttribute(HtmlTextWriterAttribute.Onclick, "if (typeof(Page_ClientValidate) == 'function') Page_ClientValidate();");
				writer.AddAttribute("language", "javascript");
			}

			base.AddAttributesToRender(writer);
		}

		public void RaisePostBackEvent(string eventArgument)
		{
			if (CausesValidation) Page.Validate();
			OnCommand();
			OnClick();
		}

		protected void OnCommand()
		{
			if (Command != null)
				Command(this, new CommandEventArgs(CommandName, CommandArgument));
		}

		protected void OnClick()
		{
			if (Click != null)
				Click(this, EventArgs.Empty);
		}
		#endregion 
	}
}
