using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.DropDownList
{
	[DefaultProperty("Text"), 
	ToolboxData("<{0}:DropDownListFully runat=server></{0}:DropDownListFully>")]
	public class DropDownListFully : SimpleListControl, IPostBackDataHandler
	{
		private bool autoPostBack = false;
		private bool isRunTime = false;

		#region Ӽ
		[Bindable(true), 
		Category("Behavior"), 
		DefaultValue(false)]
		public bool AutoPostBack {
			get	{return autoPostBack;}
			set	{autoPostBack = value;}
		}
		#endregion

		#region ޼ҵ
		protected override void RenderContents(System.Web.UI.HtmlTextWriter writer)
		{
			foreach (ListItem item in Items) {
				if (item.Selected)
					writer.AddAttribute(HtmlTextWriterAttribute.Selected, null);
				writer.AddAttribute(HtmlTextWriterAttribute.Value, item.Value);
				writer.RenderBeginTag(HtmlTextWriterTag.Option);
				writer.Write(item.Text);
				writer.RenderEndTag();
				writer.WriteLine();
			}

			base.RenderContents(writer);
		}

		protected override void AddAttributesToRender(System.Web.UI.HtmlTextWriter writer)
		{
			//'name' Ǿ LoadPostData ̺Ʈ ߻Ѵ.
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);

			// Ÿӿ  ʵѴ.
			// Ÿӿ Ⱑ Ǹ Request ü 
			//    Ʈ  ̻ϰ δ.
			if (isRunTime)	{
				//W3C XML Doom  1̻̰ ECMAScript  1.2 ̻
				bool scriptEnable = Page.Request.Browser.W3CDomVersion.Major >= 1 && 
					Page.Request.Browser.EcmaScriptVersion.CompareTo(new Version(1, 2)) >= 0;
				if (autoPostBack && scriptEnable)
					writer.AddAttribute(HtmlTextWriterAttribute.Onchange, Page.GetPostBackClientEvent(this, "test"));
			}

			base.AddAttributesToRender(writer);
		}

		public bool LoadPostData(string postDataKey, System.Collections.Specialized.NameValueCollection postCollection)
		{
			//õ  
			string selectedValue = postCollection[postDataKey];
			bool changed = false;

			//SelectedIndex == -1 && Items[0].Value == selectedValue 
			// õ  鼭 ״ ù° õ 
			//̹Ƿ ȭ   ǹѴ.
			if (!(SelectedIndex == -1 && Items[0].Value == selectedValue) 
				// ˻   SelectedItem 
				//null   ش
				&& (SelectedIndex == -1
				|| selectedValue != SelectedItem.Value))
			{
				changed = true;

				// SelectedIndex  
				// Value ؼ Ѵ. 
				for (int i=0; i<Items.Count; i++)
					if (Items[i].Value == selectedValue) {
						// SelectIndex  Ѵ.
						SelectedIndex = i;
						break;
					}
			}

			return changed;
		}

		public void RaisePostDataChangedEvent()
		{
			Page.Validate();
			OnSelectedIndexChanged(EventArgs.Empty);
		}
		#endregion

		#region ̺Ʈ
		protected override void OnPreRender(System.EventArgs e)
		{
			// Ÿӿ  ޼ҵ尡 ȣ ʴ´.
			isRunTime = true;
			base.OnPreRender(e);
		}
		#endregion 
	}
}
