using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Event
{
	public class PostBackData : WebControl, IPostBackDataHandler
	{
		public event EventHandler TextChanged;

		public string Text {
			get	{
				object o = ViewState["text"];
				return (o == null) ? String.Empty : (string)o;
			}
			set	{ViewState["text"] = value;}
		}

		public PostBackData() : base(HtmlTextWriterTag.Input) {}

		public bool LoadPostData(string postDataKey, System.Collections.Specialized.NameValueCollection postCollection)
		{
			string newVal = postCollection[postDataKey];

			if(Text != newVal) {
				Text = newVal;
				return true;
			}
			return false;
		}

		public void RaisePostDataChangedEvent()
		{
			if (TextChanged != null)
				TextChanged(this, EventArgs.Empty);
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer)
		{
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);
			writer.AddAttribute(HtmlTextWriterAttribute.Type, "input");
			writer.AddAttribute(HtmlTextWriterAttribute.Value, Text);
			base.AddAttributesToRender(writer);
		}
	}
}