using System;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using System.Drawing;
using System.Collections;
using System.Text.RegularExpressions;
using System.Web.UI.HtmlControls;

namespace MyWebLibs.ServerControls
{
	[DefaultProperty("AllowCustomPaging"), 
	ToolboxData("<{0}:PagerSkinGrid runat=server></{0}:PagerSkinGrid>")]
	public class PagerSkinGrid : DataGrid, IPostBackEventHandler
	{
		#region ڿ  
		private const string LAYOUT_OPEN = "{{̾ƿ}}";
		private const string LAYOUT_CLOSE = "{{̾ƿ}}";
		private const string BUTTON_FIRST = "{{ưó}}";
		private const string BUTTON_LAST = "{{ư}}";
		private const string BUTTON_PREV_LINK = "{{ưũ}}";
		private const string BUTTON_NEXT_LINK = "{{ưũ}}";
		private const string BUTTON_LIST = "{{ưƮ}}";
		private const string BUTTON_PREV = "{{ư}}";
		private const string BUTTON_NEXT = "{{ư}}";

		private const string PAGE_BUTTON = "{{ư}}";

		private const string DEF_BUTTON_BEGIN = "{{ưǽ}}";
		private const string DEF_BUTTON_END = "{{ưǳ}}";
		private const string DEF_SELECTED_BUTTON_BEGIN = "{{õưǽ}}";
		private const string DEF_SELECTED_BUTTON_END = "{{õưǳ}}";

		private const string DEF_BUTTON_PREV_BEGIN = "{{ưǽ}}";
		private const string DEF_BUTTON_PREV_END = "{{ưǳ}}";
		private const string DEF_BUTTON_NEXT_BEGIN = "{{ưǽ}}";
		private const string DEF_BUTTON_NEXT_END = "{{ưǳ}}";
	
		private const string DEF_BUTTON_BETWEEN_BEGIN = "{{ưǽ}}";
		private const string DEF_BUTTON_BETWEEN_END = "{{ưǳ}}";
		private const string DEF_BUTTON_FIRST_BEGIN = "{{ưóǽ}}";
		private const string DEF_BUTTON_FIRST_END = "{{ưóǳ}}";
		private const string DEF_BUTTON_LAST_BEGIN = "{{ưǽ}}";
		private const string DEF_BUTTON_LAST_END = "{{ưǳ}}";
		private const string DEF_BUTTON_PREV_LINK_BEGIN = "{{ưũǽ}}";
		private const string DEF_BUTTON_PREV_LINK_END = "{{ưũǳ}}";
		private const string DEF_BUTTON_NEXT_LINK_BEGIN = "{{ưũǽ}}";
		private const string DEF_BUTTON_NEXT_LINK_END = "{{ưũǳ}}";
		#endregion

		#region   
		private HtmlAnchor _pagerFirst1 = null;
		private HtmlAnchor _pagerLast1 = null;
		private LinkButton _pagerPrevLink1 = null;
		private LinkButton _pagerNextLink1 = null;
		private ArrayList _pagerPageList1 = new ArrayList();
		private Control _pagerPrev1 = null;
		private Control _pagerNext1 = null;

		private HtmlAnchor _pagerFirst2 = null;
		private HtmlAnchor _pagerLast2 = null;
		private LinkButton _pagerPrevLink2 = null;
		private LinkButton _pagerNextLink2 = null;
		private ArrayList _pagerPageList2 = new ArrayList();
		private Control _pagerPrev2 = null;
		private Control _pagerNext2 = null;

		private string _pagerPageButtonDef = null;

		private string _pagerSelectedPageButtonPront = null;
		private string _pagerSelectedPageButtonBack = null;
		private string _pagerPageButtonBetween = " ";

		private Control _pager1 = null; //
		private Control _pager2 = null; //ϴ
		private bool _enablePager1 = false;
		private bool _enablePager2 = false;
		private string _pagerSkinFile;
		private bool _enablePagerSkin;

		private ArrayList _exportedPagerArr = new ArrayList();
		private bool _enableExportPager;
		private bool _enableInnerPager = true;

		private int _replaceCount = 0;
		#endregion

		#region Ӽ 

		[DefaultValue(true),
		Category(" Ȯ")]
		public bool EnableInnerPager {
			get	{return _enableInnerPager;}
			set	{_enableInnerPager = value;}
		}

		[DefaultValue(false),
		Category(" Ȯ")]
		public bool EnableExportPager {
			get	{return _enableExportPager;}
			set	{_enableExportPager = value;}
		}

		[DefaultValue(false),
		Category(" Ȯ")]
		public virtual bool EnablePagerSkin	{
			get {return _enablePagerSkin;}
			set	{_enablePagerSkin = value;}
		}

		[DefaultValue(""),
		Category(" Ȯ")]
		public virtual string PagerSkinFile	{
			get	{return _pagerSkinFile;}
			set	{_pagerSkinFile = value;}
		}

		// ܺ  ȯѴ.
		[Browsable(false),
		DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public Control ExportedPager {
			get	{
				//̷ϸ ܺ ڿ Ѱ谡 .
				Control o = new Control();
				_exportedPagerArr.Add(o);
				return o;
			}
		}

		//   ÷ ȯѴ
		[Browsable(false),
		DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public ArrayList ExportedPagers {
			get	{return _exportedPagerArr;}
		}
		#endregion

		#region ȣ   ޼ҵ 
		protected override void OnItemCreated(System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			ListItemType itemType = e.Item.ItemType;

			if (itemType == ListItemType.Pager) {
				_replaceCount++;

				//ó û(Ʈ ƴҶ) Ⱑ ѹ(2)  
				//ʹ 3(6)̳ Ǳ  ī͸ ̿ ذߴ.
				if (_replaceCount % 2 == 1)
					_pager1 = e.Item.Controls[0];  //
				else
					_pager2 = e.Item.Controls[0];  //ϴ
			}

			base.OnItemCreated(e);
		}

		protected override void OnPreRender(System.EventArgs e)
		{
			base.OnPreRender(e);

			if (!_enablePagerSkin || !this.AllowPaging || (!_enableInnerPager && !_enableExportPager))
				return;

			//_pager1 _pager2 null ̸ ׸ ϳ  ̴.
			if (_pager1 == null && _pager2 == null)
				return;

			//  Ǵ Ѵ.
			//_enablePager1  , _enablePager2 ϴ 
			_enablePager1 = (this.PagerStyle.Position == PagerPosition.TopAndBottom 
				|| this.PagerStyle.Position == PagerPosition.Top);
			_enablePager2 = (this.PagerStyle.Position == PagerPosition.TopAndBottom 
				|| this.PagerStyle.Position == PagerPosition.Bottom);

			// disable̸ ܺ   Ѱ  Ȱȭ Ǹ ȴ.
			//PagerPosition.TopAndBottom ̸   .  ..
			if (!_enableInnerPager && this.PagerStyle.Position == PagerPosition.TopAndBottom)
				_enablePager1 = false;

			//  Ʈѵ  иѴ.
			BreakOriginalPager();
			_pager1.Controls.Clear();
			_pager2.Controls.Clear();

			//Ų  о´
			StreamReader sr = new StreamReader((System.IO.Stream)File.OpenRead(Page.MapPath(PagerSkinFile)), System.Text.Encoding.Default);
			string strSkin = sr.ReadToEnd();
			sr.Close();

			Regex digitregex = new Regex("(?<symbol>{{[^{}]+}})");
			MatchCollection mcMain = digitregex.Matches(strSkin);

			RealizeSymbols(mcMain, strSkin);

			if ( mcMain.Count > 0 )
			{
				// ̾ƿ κ ´. {{̾ƿ}}...{{̾ƿ}}
				string pagerTemplate = GetPortion(strSkin, LAYOUT_OPEN, LAYOUT_CLOSE, mcMain);
				if (pagerTemplate == null)
					throw new Exception(LAYOUT_OPEN + "(̳) " + LAYOUT_CLOSE + " ǰ ߸Ǿϴ.");
				
				MatchCollection mcTemplate = digitregex.Matches(pagerTemplate);
				if (mcTemplate.Count > 0)
				{
					for (int i=0; i < mcTemplate.Count; i++) 
					{
						string frontPortion, backPortion;

						if (i == 0)
						{
							frontPortion = GetFrontPortion(pagerTemplate, mcTemplate, i);
							if (frontPortion != String.Empty)
								AddLiteralControlToPager(frontPortion);

							SetupEachControl(mcTemplate[i]);

							backPortion = GetBackPortion(pagerTemplate, mcTemplate, i);
							if (backPortion != String.Empty)
								AddLiteralControlToPager(backPortion);
						}
						else
						{
							SetupEachControl(mcTemplate[i]);

							backPortion = GetBackPortion(pagerTemplate, mcTemplate, i);
							if (backPortion != String.Empty)
								AddLiteralControlToPager(backPortion);
						}
					}
				}
				if (!_enableInnerPager)
					_pager2.Controls.Clear();
			}
		}

		//DataGrid  ó   ư Ƿ
		//  ư   óѴ.
		public void RaisePostBackEvent(string eventArgument)
		{
			if (eventArgument == "first") {
				DataGridPageChangedEventArgs e = new DataGridPageChangedEventArgs(this, 0);
				OnPageIndexChanged(e);
			}

			if (eventArgument == "last") {
				DataGridPageChangedEventArgs e = new DataGridPageChangedEventArgs(this, this.PageCount-1);
				OnPageIndexChanged(e);
			}
		}

		protected override void LoadViewState(object savedState) 
		{
			if (savedState!= null) {
				object[] oState = (object[])savedState;

				if (oState[0] != null)
					base.LoadViewState(oState[0]);
				if (oState[1] != null)
					_pagerSkinFile = oState[1].ToString();
				if (oState[2] != null)
					_enablePagerSkin = Convert.ToBoolean(oState[2]);
				if (oState[3] != null)
					_enableExportPager = Convert.ToBoolean(oState[3]);
				if (oState[4] != null)
					_enableInnerPager = Convert.ToBoolean(oState[4]);
			}
		}

		protected override object SaveViewState()
		{
			object[] oState = new object[5];

			oState[0] = base.SaveViewState();
			oState[1] = PagerSkinFile;
			oState[2] = _enablePagerSkin;
			oState[3] = _enableExportPager;
			oState[4] = _enableInnerPager;

			return oState;
		}
		#endregion

		#region  ޼ҵ 

		// ܺ  ڷ ־ Ʈ ߰Ѵ.
		private void AddControlToExportPagers(Control o)
		{
			//HtmlAnchor Ʈ̸
			HtmlAnchor ha = o as HtmlAnchor;
			if (ha != null)
			{
				foreach(Control exportedPager in _exportedPagerArr)
				{
					//ܺο  Ʈ  ֱ⶧
					if (exportedPager != null)
					{
						HtmlAnchor tha = new HtmlAnchor();
						tha.InnerHtml = ha.InnerHtml;
						//ƮƮ  Ѵ.
						// hrefۿ .
						foreach (String key in ha.Attributes.Keys) {
							tha.Attributes[key] = ha.Attributes[key];	
						}
						exportedPager.Controls.Add(tha);
					}
				}

				return;
			}

			//LiteralControl ̸
			LiteralControl lc = o as LiteralControl;
			if (lc != null)
			{
				foreach(Control exportedPager in _exportedPagerArr)
				{
					//ܺο  Ʈ  ֱ⶧
					if (exportedPager != null)
					{
						LiteralControl tlc = new LiteralControl(lc.Text);
						exportedPager.Controls.Add(tlc);
					}
				}

				return;
			}

			//Label Ʈ̸
			Label lbl = o as Label;
			if (lbl != null)
			{
				foreach(Control exportedPager in _exportedPagerArr)
				{
					//ܺο  Ʈ  ֱ⶧
					if (exportedPager != null)
					{
						Label tlbl = new Label();
						tlbl.Text = lbl.Text;
						exportedPager.Controls.Add(tlbl);
					}
				}

				return;
			}
		}

		//־ ڿ LiteralControl   ߰Ѵ
		private void AddLiteralControlToPager(string text)
		{
			if (_enablePager1)
				_pager1.Controls.Add(new LiteralControl(text));
			if (_enablePager2)
				_pager2.Controls.Add(new LiteralControl(text));
			if (_enableExportPager)
				AddControlToExportPagers(new LiteralControl(text));
		}
			
		//{{̾ƿ}}̿   κ  ڿ 
		// ϰų  Ʈ Ѵ.
		private void RealizeSymbols(MatchCollection mc, string strSkin)
		{
			//{{ư}}
			string defButton = GetPortion(strSkin, DEF_BUTTON_BEGIN, DEF_BUTTON_END, mc);
			if (defButton != null)
			{
				_pagerPageButtonDef = defButton;
			}

			//{{õư}}
			string defSelectedButton = GetPortion(strSkin, DEF_SELECTED_BUTTON_BEGIN, DEF_SELECTED_BUTTON_END, mc);
			if (defSelectedButton != null)
			{
				int sepPos = defSelectedButton.IndexOf(PAGE_BUTTON);
				_pagerSelectedPageButtonPront = defSelectedButton.Substring(0, sepPos);
				_pagerSelectedPageButtonBack = defSelectedButton.Substring(sepPos + PAGE_BUTTON.Length);
			}

			//{{ư}}
			string defButtonBetween = GetPortion(strSkin, DEF_BUTTON_BETWEEN_BEGIN, DEF_BUTTON_BETWEEN_END, mc);
			if (defButtonBetween != null)
			{
				_pagerPageButtonBetween = defButtonBetween;
			}

			//{{ưó}}
			string defButtonFirst = GetPortion(strSkin, DEF_BUTTON_FIRST_BEGIN, DEF_BUTTON_FIRST_END, mc);
			if (_enablePager1) //  
			{
				//DataGrid  ù  ư Ƿ
				// IPostBackEventHandler Ͽ ̺Ʈ óѴ.
				_pagerFirst1 = new System.Web.UI.HtmlControls.HtmlAnchor();
				_pagerFirst1.InnerText = "First";
				_pagerFirst1.Attributes["href"] = Page.GetPostBackClientHyperlink(this,"first");
				if (defButtonFirst != null)
				{
					_pagerFirst1.InnerText = defButtonFirst;
				}
			}
			if (_enablePager2) // ϴ 
			{
				_pagerFirst2 = new System.Web.UI.HtmlControls.HtmlAnchor();
				_pagerFirst2.InnerText = "First";
				_pagerFirst2.Attributes["href"] = Page.GetPostBackClientHyperlink(this,"first");
				if (defButtonFirst != null)
				{
					_pagerFirst2.InnerText = defButtonFirst;
				}
			}

			//{{ư}}
			string defButtonLast = GetPortion(strSkin, DEF_BUTTON_LAST_BEGIN, DEF_BUTTON_LAST_END, mc);
			if (_enablePager1) //  
			{
				//DataGrid     ư Ƿ
				// IPostBackEventHandler Ͽ ̺Ʈ óѴ.
				_pagerLast1 = new System.Web.UI.HtmlControls.HtmlAnchor();
				_pagerLast1.InnerText = "Last";
				_pagerLast1.Attributes["href"] = Page.GetPostBackClientHyperlink(this,"last");
				if (defButtonLast != null)
				{
					_pagerLast1.InnerHtml = defButtonLast;
				}
			}
			if (_enablePager2) // ϴ 
			{
				_pagerLast2 = new System.Web.UI.HtmlControls.HtmlAnchor();
				_pagerLast2.InnerText = "Last";
				_pagerLast2.Attributes["href"] = Page.GetPostBackClientHyperlink(this,"last");
				if (defButtonLast != null)
				{
					_pagerLast2.InnerHtml = defButtonLast;
				}
			}

			//{{ưũ}}
			string defButtonPrevLink = GetPortion(strSkin, DEF_BUTTON_PREV_LINK_BEGIN, DEF_BUTTON_PREV_LINK_END, mc);
			if (_enablePager1) //  
			{
				if (_pagerPrevLink1 != null)
				{
					if (defButtonPrevLink != null)
					{
						_pagerPrevLink1.Text = defButtonPrevLink;
					}
				}
			}
			if (_enablePager2) // ϴ 
			{
				if (_pagerPrevLink2 != null)
				{
					if (defButtonPrevLink != null)
					{
						_pagerPrevLink2.Text = defButtonPrevLink;
					}
				}
			}

			//{{ưũ}}
			string defButtonNextLink = GetPortion(strSkin, DEF_BUTTON_NEXT_LINK_BEGIN, DEF_BUTTON_NEXT_LINK_END, mc);
			if (_enablePager1) //  
			{
				if (_pagerNextLink1 != null)
				{
					if (defButtonNextLink != null)
					{
						_pagerNextLink1.Text = defButtonNextLink;
					}
				}
			}
			if (_enablePager2) // ϴ 
			{
				if (_pagerNextLink2 != null)
				{
					if (defButtonNextLink != null)
					{
						_pagerNextLink2.Text = defButtonNextLink;
					}
				}
			}

			//{{ư}}
			string defButtonPrev = GetPortion(strSkin, DEF_BUTTON_PREV_BEGIN, DEF_BUTTON_PREV_END, mc);
			if (_enablePager1) //  
			{
				if (_pagerPrev1 != null)
				{
					if (defButtonPrev != null)
					{
						// ̵   _pagerPrev1 LinkButton̰
						// _pagerPrev1 Label Ʈ̴
						try
						{
							((LinkButton)_pagerPrev1).Text = defButtonPrev;
						}
						catch
						{
							((Label)_pagerPrev1).Text = defButtonPrev;
						}
					}
				}
			}
			if (_enablePager2) // ϴ 
			{
				if (_pagerPrev2 != null)
				{
					if (defButtonPrev != null)
					{
						// ̵   _pagerPrev2 LinkButton̰
						// _pagerPrev2 Label Ʈ̴
						try
						{
							((LinkButton)_pagerPrev2).Text = defButtonPrev;
						}
						catch
						{
							((Label)_pagerPrev2).Text = defButtonPrev;
						}
					}
				}
			}

			//{{ư}}
			string defButtonNext = GetPortion(strSkin, DEF_BUTTON_NEXT_BEGIN, DEF_BUTTON_NEXT_END, mc);
			if (_enablePager1) //  
			{
				if (_pagerNext1 != null)
				{
					if (defButtonNext != null)
					{
						// ̵   _pagerNext1 LinkButton̰
						// _pagerNext1 Label Ʈ̴
						try
						{
							((LinkButton)_pagerNext1).Text = defButtonNext;
						}
						catch
						{
							((Label)_pagerNext1).Text = defButtonNext;
						}
					}
				}
			}
			if (_enablePager2) // ϴ 
			{
				if (_pagerNext2 != null)
				{
					if (defButtonNext != null)
					{
						// ̵   _pagerNext1 LinkButton̰
						// _pagerNext1 Label Ʈ̴
						try
						{
							((LinkButton)_pagerNext2).Text = defButtonNext;
						}
						catch
						{
							((Label)_pagerNext2).Text = defButtonNext;
						}
					}
				}
			}
		}

		//  ִ Ʈѵ Ѵ.
		// Ʈѵ  籸 Ҷ ȴ.
		private void BreakOriginalPager()
		{
			Control tmpPager;

			if (_enablePager1) //  
			{
				tmpPager = _pager1;
				//PagerStyle.Mode  ó ٸ
				if (this.PagerStyle.Mode == PagerMode.NextPrev)
				{
					int buttonIndex = 0;

					for (int i=0; i<tmpPager.Controls.Count; i+=2)
					{
						if (tmpPager.Controls[i] is LinkButton || tmpPager.Controls[i] is Label)
						{
							if (buttonIndex++ == 0)
							{	//Prev ư 
								_pagerPrev1 = tmpPager.Controls[i];
							}
							else
							{	//Next ư 
								_pagerNext1 = tmpPager.Controls[i];
							}
						}
					}
				}
				else
				{
					for (int i=0; i<tmpPager.Controls.Count; i+=2)
					{
						try
						{
							LinkButton h = (LinkButton) tmpPager.Controls[i];
							if (h.Text == "...")
							{
								//ʰ   '...'̹Ƿ ϴ  ʿϴ.
								//_pagerPageList Լ 0̸ ̴
								if (_pagerPageList1.Count == 0)
									_pagerPrevLink1 = h;
								else
									_pagerNextLink1 = h;
							}
							else
								_pagerPageList1.Add(h);
						}
						catch
						{
							_pagerPageList1.Add(tmpPager.Controls[i]);
						}
					}
				}
			}

			if (_enablePager2) // ϴ 
			{
				tmpPager = _pager2;

				//PagerStyle.Mode  ó ٸ
				if (this.PagerStyle.Mode == PagerMode.NextPrev)
				{
					int buttonIndex = 0;

					for (int i=0; i<tmpPager.Controls.Count; i+=2)
					{
						if (tmpPager.Controls[i] is LinkButton || tmpPager.Controls[i] is Label)
						{
							if (buttonIndex++ == 0)
							{
								_pagerPrev2 = tmpPager.Controls[i];
							}
							else
							{
								_pagerNext2 = tmpPager.Controls[i];
							}
						}
					}
				}
				else
				{
					for (int i=0; i<tmpPager.Controls.Count; i+=2)
					{
						try
						{
							LinkButton h = (LinkButton) tmpPager.Controls[i];
							if (h.Text == "...")
							{
								//ʰ   '...'̹Ƿ ϴ  ʿϴ.
								//_pagerPageList Լ 0̸ ̴
								if (_pagerPageList2.Count == 0)
									_pagerPrevLink2 = h;
								else
									_pagerNextLink2 = h;
							}
							else
								_pagerPageList2.Add(h);
						}
						catch
						{
							_pagerPageList2.Add(tmpPager.Controls[i]);
						}
					}
				}
			}
		}
		
		// ޼ҵ忡  ɺ  Ʈ  ߰Ѵ.
		private void SetupEachControl(Match m)
		{

			bool exportPagerProcessed = false;

			switch (m.Value)
			{
				case BUTTON_FIRST :
					if (_enablePager1) //  
					{
						//̻ ʿ    ư ʿ䰡 .
						if (_pagerPrevLink1 != null)
						{
							_pager1.Controls.Add(_pagerFirst1); //  ߰
							if (_enableExportPager)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerFirst1.InnerHtml;
								ha.Attributes["href"] = _pagerFirst1.Attributes["href"];
								//ܺ  ߰
								AddControlToExportPagers(ha);
								exportPagerProcessed = true;
							}
						}
					}
					if (_enablePager2) // ϴ 
					{
						//̻ ʿ    ư ʿ䰡 .
						if (_pagerPrevLink2 != null)
						{
							_pager2.Controls.Add(_pagerFirst2); //  ߰
							if (_enableExportPager && !exportPagerProcessed)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerFirst2.InnerHtml;
								ha.Attributes["href"] = _pagerFirst2.Attributes["href"];
								//ܺ  ߰
								AddControlToExportPagers(ha);
							}
						}
					}

					break;
				case BUTTON_LAST :
					if (_enablePager1)
					{
						//̻ ʿ   ̹ư ʿ䰡 .
						if (_pagerNextLink1 != null)
						{
							_pager1.Controls.Add(_pagerLast1);
							if (_enableExportPager)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerLast1.InnerHtml;
								ha.Attributes["href"] = _pagerLast1.Attributes["href"];
								AddControlToExportPagers(ha);
								exportPagerProcessed = true;
							}
						}
					}
					if (_enablePager2)
					{
						//̻ ʿ   ̹ư ʿ䰡 .
						if (_pagerNextLink2 != null)
						{
							_pager2.Controls.Add(_pagerLast2);
							if (_enableExportPager && !exportPagerProcessed)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerLast2.InnerHtml;
								ha.Attributes["href"] = _pagerLast2.Attributes["href"];
								AddControlToExportPagers(ha);
							}
						}
					}
					break;
				case BUTTON_PREV :
					if (_enablePager1)
					{
						_pager1.Controls.Add(_pagerPrev1);
						if (_enableExportPager)
						{
							if (_pagerPrev1 is LinkButton)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = ((LinkButton)_pagerPrev1).Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerPrev1, ((LinkButton)_pagerPrev1).CommandName);
								AddControlToExportPagers(ha);
							}
							else
							{
								LiteralControl ha = new LiteralControl(((Label)_pagerPrev1).Text);
								AddControlToExportPagers(ha);
							}
							exportPagerProcessed = true;
						}
					}
					if (_enablePager2)
					{
						_pager2.Controls.Add(_pagerPrev2);
						if (_enableExportPager && !exportPagerProcessed)
						{
							if (_pagerPrev2 is LinkButton)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = ((LinkButton)_pagerPrev2).Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerPrev2, ((LinkButton)_pagerPrev2).CommandName);
								AddControlToExportPagers(ha);
							}
							else
							{
								LiteralControl ha = new LiteralControl(((Label)_pagerPrev2).Text);
								AddControlToExportPagers(ha);
							}
						}
					}
					break;
				case BUTTON_NEXT :
					if (_enablePager1)
					{
						_pager1.Controls.Add(_pagerNext1);
						if (_enableExportPager)
						{
							if (_pagerNext1 is LinkButton)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = ((LinkButton)_pagerNext1).Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerNext1, ((LinkButton)_pagerNext1).CommandName);
								AddControlToExportPagers(ha);
							}
							else
							{
								LiteralControl ha = new LiteralControl(((Label)_pagerNext1).Text);
								AddControlToExportPagers(ha);
							}
							exportPagerProcessed = true;
						}
					}
					if (_enablePager2)
					{
						_pager2.Controls.Add(_pagerNext2);
						if (_enableExportPager && !exportPagerProcessed)
						{
							if (_pagerNext2 is LinkButton)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = ((LinkButton)_pagerNext2).Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerNext2, ((LinkButton)_pagerNext2).CommandName);
								AddControlToExportPagers(ha);
							}
							else
							{
								LiteralControl ha = new LiteralControl(((Label)_pagerNext2).Text);
								AddControlToExportPagers(ha);
							}
						}
					}
					break;
				case BUTTON_PREV_LINK :
					if (_enablePager1)
					{
						if (_pagerPrevLink1 != null)
						{
							_pager1.Controls.Add(_pagerPrevLink1);
							if (_enableExportPager)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerPrevLink1.Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerPrevLink1, _pagerPrevLink1.CommandName);
								AddControlToExportPagers(ha);
								exportPagerProcessed = true;
							}
						}
					}
					if (_enablePager2)
					{
						if (_pagerPrevLink2 != null)
						{
							_pager2.Controls.Add(_pagerPrevLink2);
							if (_enableExportPager && !exportPagerProcessed)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerPrevLink2.Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerPrevLink2, _pagerPrevLink2.CommandName);
								AddControlToExportPagers(ha);
							}
						}
					}
					break;
				case BUTTON_NEXT_LINK :
					if (_enablePager1)
					{
						if (_pagerNextLink1 != null)
						{
							_pager1.Controls.Add(_pagerNextLink1);
							if (_enableExportPager)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerNextLink1.Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerNextLink1, _pagerNextLink1.CommandName);
								AddControlToExportPagers(ha);
								exportPagerProcessed = true;
							}
						}
					}
					if (_enablePager2)
					{
						if (_pagerNextLink2 != null)
						{
							_pager2.Controls.Add(_pagerNextLink2);
							if (_enableExportPager && !exportPagerProcessed)
							{
								HtmlAnchor ha = new HtmlAnchor();
								ha.InnerHtml = _pagerNextLink2.Text;
								ha.Attributes["href"] = this.Page.GetPostBackClientHyperlink(_pagerNextLink2, _pagerNextLink2.CommandName);
								AddControlToExportPagers(ha);
							}
						}
					}
					break;
				case BUTTON_LIST :
					if (_enablePager1)
					{
						for (int i=0; i<_pagerPageList1.Count; i++)
						{
							//õ  Label Ʈ̰ 
							// ƴϸ LinkButton Ʈ̴
							LinkButton lb = _pagerPageList1[i] as LinkButton;
							Control ep = null;
							if (lb != null)
							{ // Ϲ 
								//PAGE_BUTTON ɺ ư ڿ ȯѴ
								lb.Text = _pagerPageButtonDef.Replace(PAGE_BUTTON, lb.Text);
								if (_enableExportPager)
								{	// ܺ  ߰ Ʈ 
									ep = (Control)new HtmlAnchor();
									((HtmlAnchor)ep).InnerHtml = lb.Text;
									//̷ ϸ ܺη  Ʈ ̸   ʵȴ.
									//ϰִ ̳ʵ ̸ .
									//׷ Ʒóߴµ   ƴϴ.
									//   ãƾ...
									//((HtmlAnchor)ep).Attributes["href"] = this.Page.GetPostBackClientHyperlink(lb, lb.CommandName);
									((HtmlAnchor)ep).Attributes["href"] = "javascript:__doPostBack('" + _pager1.Parent.UniqueID + ":" + lb.UniqueID + "','')";
								}
							}
							else
							{ // õ 
								Label l = (Label)_pagerPageList1[i];
								l.Text = _pagerSelectedPageButtonPront + l.Text + _pagerSelectedPageButtonBack;
								if (_enableExportPager)
								{	// ܺ  ߰ Ʈ 
									ep = (Control)new Label();
									((Label)ep).Text = l.Text;
								}
							}
							// Ų Ʈѵ  _pagerPageList[i]  ֱ   ̷..
							_pager1.Controls.Add((Control)_pagerPageList1[i]); //   ߰
							if (_enableExportPager)
							{	// ܺ  ߰
								AddControlToExportPagers(ep);
							}

							// ưڿ ߰ ʴ´.
							if (i < _pagerPageList1.Count-1)
							{	//  ư ̿ LiteralControl ߰Ѵ
								//  ߰
								_pager1.Controls.Add(new LiteralControl(_pagerPageButtonBetween));
								if (_enableExportPager)
								{	//ܺ  ߰
									AddControlToExportPagers(new LiteralControl(_pagerPageButtonBetween));
								}
							}
						}
						exportPagerProcessed = true;
					}
					if (_enablePager2)
					{
						//for (int i=0; i<this.PagerStyle.PageButtonCount; i++)
						for (int i=0; i<_pagerPageList2.Count; i++)
						{
							LinkButton lb = _pagerPageList2[i] as LinkButton;
							Control ep = null;
							if (lb != null)
							{
								lb.Text = _pagerPageButtonDef.Replace(PAGE_BUTTON, lb.Text);
								if (_enableExportPager && !exportPagerProcessed)
								{
									ep = (Control)new HtmlAnchor();
									((HtmlAnchor)ep).InnerHtml = lb.Text;
									//̷ ϸ ܺη  Ʈ ̸   ʵȴ.
									//ϰִ ̳ʵ ̸ .
									//׷ Ʒóߴµ   ƴϴ.
									//   ãƾ...
									//((HtmlAnchor)ep).Attributes["href"] = this.Page.GetPostBackClientHyperlink(lb, lb.CommandName);
									((HtmlAnchor)ep).Attributes["href"] = "javascript:__doPostBack('" + _pager2.Parent.UniqueID + ":" + lb.UniqueID + "','')";
								}
							}
							else
							{
								Label l = (Label)_pagerPageList2[i];
								l.Text = _pagerSelectedPageButtonPront + l.Text + _pagerSelectedPageButtonBack;
								if (_enableExportPager && !exportPagerProcessed)
								{
									ep = (Control)new Label();
									((Label)ep).Text = l.Text;
								}
							}
							// Ų Ʈѵ  _pagerPageList[i]  ֱ   ̷..
							_pager2.Controls.Add((Control)_pagerPageList2[i]);
							if (_enableExportPager && !exportPagerProcessed)
							{
								//_exportedPager.Controls.Add(ep);
								AddControlToExportPagers(ep);
								
							}

							// ưڿ ߰ ʴ´.
							if (i < _pagerPageList2.Count-1)
							{
								_pager2.Controls.Add(new LiteralControl(_pagerPageButtonBetween));
								if (_enableExportPager && !exportPagerProcessed)
								{
									//_exportedPager.Controls.Add(new LiteralControl(_pagerPageButtonBetween));
									AddControlToExportPagers(new LiteralControl(_pagerPageButtonBetween));
								}
							}
						}
					}
					break;
			}
		}

		//ɺ  ͷ̵ ڿ ´.
		private string GetFrontPortion(string origin, MatchCollection mc, int index)
		{
			if (index == 0)
			{
				return origin.Substring(0, mc[index].Index);
			}
			else
			{
				return origin.Substring(mc[index-1].Index+mc[index-1].Length, 
					mc[index].Index - (mc[index-1].Index+mc[index-1].Length));
			}
		}

		//ɺ Ĺ ͷ̵ ڿ ´.
		private string GetBackPortion(string origin, MatchCollection mc, int index)
		{
			if (index == mc.Count-1)
			{
				return origin.Substring(mc[index].Index + mc[index].Length);
			}
			else
			{
				return origin.Substring(mc[index].Index + mc[index].Length, 
					mc[index + 1].Index - (mc[index].Index+mc[index].Length));
			}
		}

		//startSymbol enSynbol Ʈ ´.
		private string GetPortion(string origin, string startSymbol, string endSymbol, MatchCollection mc)
		{
			Match sm = FindMatche(mc, startSymbol);
			if (sm == null)
				return null;
			//throw new Exception(startSymbol + " ɺ ϴ.");

			Match em = FindMatche(mc, endSymbol);
			if (em == null)
				return null;
			//throw new Exception(endSymbol + " ɺ ϴ.");

			int iStart = sm.Index + sm.Length;
			int iLength = em.Index - iStart;

			return origin.Substring(iStart, iLength);
		}

		private Match FindMatche(MatchCollection mc, string search)
		{
			foreach (Match m in mc) 
			{
				if (search == m.Value)
					return m;
			}

			return null;
		}
		#endregion
	}
}