namespace PowerOfDotNet.Shop
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		ShopProdList   Դϴ.
	/// </summary>
	public abstract class ShopProdList : PowerOfDotNet.PortalModuleControl
	{
		protected System.Web.UI.HtmlControls.HtmlTableCell tdPager;
		protected System.Web.UI.WebControls.DataList datlstProducts;

		private const int intPageSize = 8;
		private int _indexId;
		private int _page;

		private void Page_Load(object sender, System.EventArgs e)
		{
			_indexId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["indexId"], -1);
			_page = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["page"], 0);
			BindDataGrid();
		}

		private void BindDataGrid()
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Name", typeof(string)));
			dt.Columns.Add(new DataColumn("Price", typeof(Int32)));
			dt.Columns.Add(new DataColumn("DiscountPercent", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Absence", typeof(bool)));

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			DataTable dtSource = db.GetProductListByIndexId(_indexId).Tables[0];

			int intTotalCount = dtSource.Rows.Count;
			
			int intStartRow = _page * intPageSize;
			int intEndRow = (intStartRow+intPageSize <= intTotalCount) ? intStartRow+intPageSize : intTotalCount;

			for (int intIndex=intStartRow; intIndex < intEndRow; intIndex++)
			{
				dr = dt.NewRow();

				dr[0] = dtSource.Rows[intIndex]["ID"];
				dr[1] = dtSource.Rows[intIndex]["Name"];
				dr[2] = dtSource.Rows[intIndex]["Price"];
				dr[3] = dtSource.Rows[intIndex]["DiscountPercent"];
				dr[4] = dtSource.Rows[intIndex]["Absence"];

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);

			datlstProducts.DataSource = new DataView(dt);
			datlstProducts.DataBind();

			ShopMethods.CreatePager(tdPager, _page, intTotalCount, intPageSize, 10, GetLink("īǰ") + "&indexId=" + _indexId, "page");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
