using System;
using System.IO;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using PowerOfDotNet.TypedDataSet;

namespace PowerOfDotNet.Components
{
	/// <summary>
	/// DownloadDB   Դϴ.
	/// </summary>
	public class DownloadDB
	{
		public DownloadDB()
		{
		}

		/*
		public DataSet ReadList(int intPage, int intRowCount, byte bytCategory, string strSortMethod)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			SqlDataAdapter myCommand = new SqlDataAdapter("SP_GET_DOWNLOAD_BOARD_LIST", myConnection);
			myCommand.SelectCommand.CommandType = CommandType.StoredProcedure;

			myCommand.SelectCommand.Parameters.Add(new SqlParameter("@PAGE", SqlDbType.Int, 4)).Value = intPage;
			myCommand.SelectCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.SelectCommand.Parameters.Add(new SqlParameter("@CATEGORY", SqlDbType.TinyInt)).Value = bytCategory;
			myCommand.SelectCommand.Parameters.Add(new SqlParameter("@SORTMETHOD", SqlDbType.VarChar, 20)).Value = strSortMethod;

			DataSet ds = new DataSet();
			myCommand.Fill(ds, "DownloadBoard");

			return ds;
		}*/

		public SqlDataReader GetSqlRecentSubject(int topCount)
		{
			string sql = "select top " + topCount + " dnSubject, dnWriterName from DownloadBoard order by dnID desc";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getSubjectCmd = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = getSubjectCmd.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public DataSet CategoryList()
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			SqlDataAdapter myCommand = new SqlDataAdapter("select * from CategoryAspDotNet", myConnection);

			DataSet ds = new DataSet();
			myCommand.Fill(ds, "CategoryAspDotNet");

			return ds;
		}

		public void AddNewUpload(DownloadDS oDS, HttpPostedFile oPF, byte bytCategoryNum, 
								byte bytLanguageNum, string strDescription, string strSubject, 
								string strWriterID, string strWriterName, byte bytTarget)
		{
			DownloadDS.DownloadBoardRow oRow = oDS.DownloadBoard.NewDownloadBoardRow();
			oRow.dnCategory = bytCategoryNum;
			oRow.dnLanguage = bytLanguageNum;
			oRow.dnSubject = strSubject;
			oRow.dnDescription = strDescription;
			oRow.dnWriterID = strWriterID;
			oRow.dnWriterName = strWriterName;
			oRow.dnVoteCount = 0;
			oRow.dnRating = -1;
			oRow.dnRegDate = DateTime.Now;
			oRow.dnTarget = bytTarget;
			oRow.dnCommentCount = 0;

			string strFileName = oPF.FileName;
			int intFileNameStart = strFileName.LastIndexOf(@"\");
			if (intFileNameStart > 0)
				strFileName = strFileName.Substring(intFileNameStart+1);

			oRow.dnFileName = strFileName;
			oDS.DownloadBoard.AddDownloadBoardRow(oRow);
			
			string strFileDirPath = HttpContext.Current.Server.MapPath("/NewStudy/DownloadBoard/UploadFiles/");
			strFileDirPath += oRow.dnID.ToString() + @"\";

			if (!Directory.Exists(strFileDirPath))
				Directory.CreateDirectory(strFileDirPath);

			oPF.SaveAs(strFileDirPath + strFileName);
			
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			string sql = "select * from DownloadBoard order by dnID desc";
			SqlDataAdapter daDownloadBoard = new SqlDataAdapter(sql, myConnection);
			SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daDownloadBoard);
			daDownloadBoard.InsertCommand = cmdBuilder.GetInsertCommand();

			sql = "select * from DownloadBoardComment order by dncID desc";
			SqlDataAdapter daComment = new SqlDataAdapter(sql, myConnection);

			sql = "select * from DownloadBoardVote";
			SqlDataAdapter daVote = new SqlDataAdapter(sql, myConnection);

			daDownloadBoard.Update(oDS,"DownloadBoard");

			//̷ϴ  ߰     ʱ⶧̴.
			oDS.DownloadBoardComment.Clear();
			oDS.DownloadBoardVote.Clear();
			oDS.DownloadBoard.Clear();

			myConnection.Open();
			daDownloadBoard.Fill(oDS, "DownloadBoard");
			daComment.Fill(oDS, "DownloadBoardComment");
			daVote.Fill(oDS, "DownloadBoardVote");
			myConnection.Close();
		}

		public void UpdateUpload(int id, DownloadDS oDS, HttpPostedFile oPF, byte bytCategoryNum, 
			byte bytLanguageNum, string strDescription, string strSubject, 
			byte bytTarget)
		{
			DownloadDS.DownloadBoardRow oRow = oDS.DownloadBoard.FindBydnID(id);
			oRow.dnCategory = bytCategoryNum;
			oRow.dnLanguage = bytLanguageNum;
			oRow.dnSubject = strSubject;
			oRow.dnDescription = strDescription;
			oRow.dnTarget = bytTarget;

			string strFileName = oPF.FileName;
			if (strFileName.Trim() != "")
			{
				int intFileNameStart = strFileName.LastIndexOf(@"\");
				if (intFileNameStart > 0)
					strFileName = strFileName.Substring(intFileNameStart+1);

				string oldFile = oRow.dnFileName;
				oRow.dnFileName = strFileName;
			
				string strFileDirPath = HttpContext.Current.Server.MapPath("/NewStudy/DownloadBoard/UploadFiles/");
				strFileDirPath += oRow.dnID.ToString() + @"\";

				if (!Directory.Exists(strFileDirPath))
					Directory.CreateDirectory(strFileDirPath);
				//  .
				if (!File.Exists(strFileDirPath + oldFile))
					File.Delete(strFileDirPath + oldFile);

				oPF.SaveAs(strFileDirPath + strFileName);
			}
			
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			string sql = "select * from DownloadBoard order by dnID desc";
			SqlDataAdapter daDownloadBoard = new SqlDataAdapter(sql, myConnection);
			SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daDownloadBoard);
			daDownloadBoard.InsertCommand = cmdBuilder.GetInsertCommand();

			daDownloadBoard.Update(oDS,"DownloadBoard");
			oDS.AcceptChanges();
		}

		public int DeleteUpload(DownloadDS oDS,int id)
		{
			// ͺ̽  Ѵ.
			//MSDN ŵȴٰ µ??
			//oDS.DownloadBoard.RemoveDownloadBoardRow(oDS.DownloadBoard.FindBydnID(id));

			//̹ ͺ̽ Ѵ.
			oDS.DownloadBoard.FindBydnID(id).Delete();

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			string sql = "select * from DownloadBoard order by dnID desc";
			SqlDataAdapter daDownloadBoard = new SqlDataAdapter(sql, myConnection);
			SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daDownloadBoard);
			daDownloadBoard.DeleteCommand = cmdBuilder.GetDeleteCommand();

			int retvar = 1;
			try
			{
				daDownloadBoard.Update(oDS,"DownloadBoard");
				oDS.AcceptChanges();
			}
			catch
			{
				retvar = -1;
			}
			return retvar;
		}

		public void IncFileDownload(DownloadDS oDS, int id)
		{
			oDS.DownloadBoard.FindBydnID(id).dnDownloadCount += 1;

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			string sql = "select * from DownloadBoard order by dnID desc";
			SqlDataAdapter daDownloadBoard = new SqlDataAdapter(sql, myConnection);
			SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daDownloadBoard);
			daDownloadBoard.UpdateCommand = cmdBuilder.GetUpdateCommand();

			daDownloadBoard.Update(oDS,"DownloadBoard");
			oDS.AcceptChanges();
		}

		public DownloadDS CreateDownloadDS()
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			string sql = "select * from DownloadBoard order by dnID desc";
			//string sql = "select * from DownloadBoard";
			SqlDataAdapter daDownloadBoard = new SqlDataAdapter(sql, myConnection);
			//SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daDownloadBoard);
			//daDownloadBoard.DeleteCommand = cmdBuilder.GetDeleteCommand();
			//daDownloadBoard.InsertCommand = cmdBuilder.GetInsertCommand();
			//daDownloadBoard.UpdateCommand = cmdBuilder.GetUpdateCommand();

			sql = "select * from DownloadBoardComment order by dncID desc";
			//sql = "select * from DownloadBoardComment";
			SqlDataAdapter daComment = new SqlDataAdapter(sql, myConnection);
			//cmdBuilder = new SqlCommandBuilder(daComment);
			//daComment.DeleteCommand = cmdBuilder.GetDeleteCommand();
			//daComment.InsertCommand = cmdBuilder.GetInsertCommand();
			//daComment.UpdateCommand = cmdBuilder.GetUpdateCommand();

			
			sql = "select * from DownloadBoardVote";
			SqlDataAdapter daVote = new SqlDataAdapter(sql, myConnection);
			//cmdBuilder = new SqlCommandBuilder(daComment);
			//daVote.DeleteCommand = cmdBuilder.GetDeleteCommand();
			//daVote.InsertCommand = cmdBuilder.GetInsertCommand();
			//daVote.UpdateCommand = cmdBuilder.GetUpdateCommand();

			// fill the typed DataSet
			DownloadDS dsAdDownload = new DownloadDS();
			myConnection.Open();
			daDownloadBoard.Fill(dsAdDownload, "DownloadBoard");
			daComment.Fill(dsAdDownload, "DownloadBoardComment");
			daVote.Fill(dsAdDownload, "DownloadBoardVote");
			myConnection.Close();

			return dsAdDownload;
		}

		public void AddReview(DownloadDS oDS, int dnID, string comment, string writerID)
		{
			DownloadDS.DownloadBoardCommentRow row = oDS.DownloadBoardComment.NewDownloadBoardCommentRow();
			row.dncDnID = dnID;
			row.dncComment = comment;
			row.dncWriterID = writerID;
			oDS.DownloadBoardComment.AddDownloadBoardCommentRow(row);

			// ī .
			oDS.DownloadBoard.FindBydnID(dnID).dnCommentCount++;

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			string sql = "select * from DownloadBoard order by dnID desc";
			SqlDataAdapter daDownloadBoard = new SqlDataAdapter(sql, myConnection);
			SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daDownloadBoard);
			daDownloadBoard.UpdateCommand = cmdBuilder.GetUpdateCommand();

			sql = "select * from DownloadBoardComment order by dncID desc";
			SqlDataAdapter daComment = new SqlDataAdapter(sql, myConnection);
			cmdBuilder = new SqlCommandBuilder(daComment);
			daComment.InsertCommand = cmdBuilder.GetInsertCommand();

			sql = "select * from DownloadBoardVote";
			SqlDataAdapter daVote = new SqlDataAdapter(sql, myConnection);

			//UpdateҶ ̺  ־Ѵ.
			//daDownloadBoard.Update(oDS, "DownloadBoard");
			daDownloadBoard.Update(oDS.DownloadBoard);
			//daComment.Update(oDS,"DownloadBoardComment");
			daComment.Update(oDS.DownloadBoardComment);

			oDS.AcceptChanges();

			//̷ϴ  ߰     ʱ⶧̴.
			oDS.DownloadBoardComment.Clear();
			oDS.DownloadBoardVote.Clear();
			oDS.DownloadBoard.Clear();

			myConnection.Open();
			daDownloadBoard.Fill(oDS, "DownloadBoard");
			daComment.Fill(oDS, "DownloadBoardComment");
			daVote.Fill(oDS, "DownloadBoardVote");
			myConnection.Close();
		}


		public void AddVote(DownloadDS oDS, int dnID, string selectedValue, string writerID)
		{
			DownloadDS.DownloadBoardVoteRow row = oDS.DownloadBoardVote.NewDownloadBoardVoteRow();
			row.dnvDnID = dnID;
			row.dnvRating = byte.Parse(selectedValue);
			row.dnvWriterID = writerID;
			oDS.DownloadBoardVote.AddDownloadBoardVoteRow(row);

			int voteTotal = 0;
			DownloadDS.DownloadBoardVoteRow[] aRows = oDS.DownloadBoard.FindBydnID(dnID).GetDownloadBoardVoteRows();
			foreach(DownloadDS.DownloadBoardVoteRow r in aRows)
			{
				voteTotal += Convert.ToInt32(r.dnvRating);
			}
			//ǥ  
			oDS.DownloadBoard.FindBydnID(dnID).dnRating = Convert.ToInt32(Math.Round((double)voteTotal / (double)aRows.Length, 0));
			//ǥ ī .
			oDS.DownloadBoard.FindBydnID(dnID).dnVoteCount++;

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			string sql = "select * from DownloadBoard order by dnID desc";
			SqlDataAdapter daDownloadBoard = new SqlDataAdapter(sql, myConnection);
			SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daDownloadBoard);
			daDownloadBoard.UpdateCommand = cmdBuilder.GetUpdateCommand();

			sql = "select * from DownloadBoardComment order by dncID desc";
			SqlDataAdapter daComment = new SqlDataAdapter(sql, myConnection);

			sql = "select * from DownloadBoardVote";
			SqlDataAdapter daVote = new SqlDataAdapter(sql, myConnection);
			cmdBuilder = new SqlCommandBuilder(daVote);
			daVote.InsertCommand = cmdBuilder.GetInsertCommand();

			//UpdateҶ ̺  ־Ѵ.
			//daDownloadBoard.Update(oDS, "DownloadBoard");
			daDownloadBoard.Update(oDS.DownloadBoard);
			//daComment.Update(oDS,"DownloadBoardVote");
			daVote.Update(oDS.DownloadBoardVote);

			oDS.AcceptChanges();

			//̷ϴ  ߰     ʱ⶧̴.
			oDS.DownloadBoardComment.Clear();
			oDS.DownloadBoardVote.Clear();
			oDS.DownloadBoard.Clear();

			myConnection.Open();
			daDownloadBoard.Fill(oDS, "DownloadBoard");
			daComment.Fill(oDS, "DownloadBoardComment");
			daVote.Fill(oDS, "DownloadBoardVote");
			myConnection.Close();
		}

/*		public void AddContent(DataContent wContent)
		{
			string sql;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand;
			//SqlDataReader myDataReader;

			wContent.Subject.Replace("'","''");
			wContent.Content.Replace("'","''");
			sql = "Insert into Review";
			sql += " (rBookNo,rWriter,rSubject,rContent,rPassword,rRegDate) ";
			sql += " values(" + wContent.BookNo + ",'" + wContent.Writer + "','" + wContent.Subject + "','" + wContent.Content + "','" + wContent.Password + "',Getdate())";

			myCommand = new SqlCommand(sql, myConnection);
			myConnection.Open();
			try 
			{ 
				myCommand.ExecuteNonQuery(); 
			} 
			catch 
			{
				myConnection.Close();
			} 
			
			myConnection.Close(); 
		}

		public void ModifyContent(DataContent arg)
		{
			string sql;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand;
			//SqlDataReader myDataReader;

			arg.Subject.Replace("'","''");
			arg.Content.Replace("'","''");
			sql = "update Review ";
			sql += " set rWriter='" + arg.Writer;
			sql += "' , rSubject='" + arg.Subject;
			sql += "' , rContent='" + arg.Content;
			sql += "' , rPassword='" + arg.Password;
			sql += "' where rID=" + arg.ID;

			myCommand = new SqlCommand(sql, myConnection);
			myConnection.Open();
			try 
			{ 
				myCommand.ExecuteNonQuery(); 
			} 
			catch 
			{
				myConnection.Close();
			} 
			
			myConnection.Close(); 
		}

		public void DeleteContent(int intRID)
		{
			string sql;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand;

			sql = "Delete From Review Where rID=" + intRID;

			myCommand = new SqlCommand(sql, myConnection);
			myConnection.Open();
			try 
			{ 
				myCommand.ExecuteNonQuery(); 
			} 
			catch 
			{ 
			} 

			myConnection.Close();
		}
		
		public DataContent GetDataContent(int RID)
		{
			string sql = "Select rBookNo,rWriter,rSubject,rContent,rRegDate,rPassword From Review where rID=" + RID.ToString();
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			// Execute the command
			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader();
			DataContent result = new DataContent();
			
			if (dr.Read()) 
			{
				result.BookNo = dr.GetByte(0);
				result.Writer = dr.GetString(1);
				result.Subject = dr.GetString(2);
				result.Content = dr.GetString(3);
				result.RegDate = dr.GetDateTime(4);
				result.Password = dr.GetString(5);
			}
			else
			{
				//ó!
			}
			dr.Close();
			myConnection.Close();

			return result;
		}*/
	}
}
