using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;

namespace PowerOfDotNet.Components
{

	public class MessageContent
	{
		public int ID;
		public string UserID;
		public string SendUserID;
		public string SenderName;
		public string SenderEmail;
		public DateTime RecivedDate;
		public bool Viewed;
		public string Message;
		public string ReciveUserIDBoxID;
	}

	public class MyPageDB
	{
		public int GetDateContent(string userId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand("UserMessageNewCount", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar)).Value = userId;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader();
			dr.Read();
			int count = (int)dr["NewCount"];
			dr.Close();
			myConnection.Close();
            
			return count;
		}

		public void DeleteMessage(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand("UserMessageDelete", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public int SendUserMessage(string userId, string sendUserID, string Message)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand receptionCommand = new SqlCommand("UserMessageSend", myConnection);

			receptionCommand.CommandType = CommandType.StoredProcedure;

			receptionCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			receptionCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			receptionCommand.Parameters.Add(new SqlParameter("@SendUserID", SqlDbType.VarChar, 12)).Value = sendUserID;
			receptionCommand.Parameters.Add(new SqlParameter("@Message", SqlDbType.Text)).Value = Message;

			myConnection.Open();

			int newId = -1;
			try 
			{
				receptionCommand.ExecuteNonQuery();
				newId = Convert.ToInt32(receptionCommand.Parameters["RETURN_VALUE"].Value);
			}
			catch (Exception err)
			{
				string s = err.Message;
			}
			finally
			{
				myConnection.Close();
			}

			return newId;
		}

		public DataSet GetUserMessageList(string userId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlDataAdapter da = new SqlDataAdapter("UserMessageGetList", myConnection);

			da.SelectCommand.CommandType = CommandType.StoredProcedure;

			da.SelectCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			DataSet ds = new DataSet();
			da.Fill(ds, "UserMessage");
			
			return ds;
		}

		// ߰ǰų   DB ߰ ޼ҵ
		public void EnterContent(string userId, DateTime dtDate, string strNote)
		{
			string sql = "select * from DailyPlan where rtUserID='" + userId + "' and rtDate='"+ dtDate.ToString("yyyy-MM-dd") +"'";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);
				
			myConnection.Open();
			SqlDataReader rowExist = myCommand.ExecuteReader();
			// ¥  ̹ ϸ Update
			if (rowExist.Read()) 
			{
				sql = "UPDATE DailyPlan SET " + 
					"rtNote='" + strNote.Replace("'", "''") + "' " +
					"WHERE rtUserID='" + userId + "' and rtDate='" + dtDate.ToString("yyyy-MM-dd") + "'";
			}
			else
			{	// ƴϸ Insert

				sql = "INSERT INTO DailyPlan " + 
					"(rtUserID,rtDate,rtNote) VALUES (" +
					"'" + userId + "'," +
					"'" + dtDate.ToString("yyyy-MM-dd") + "'," +
					"'" + strNote.Replace("'", "''") + "'" +
					")";
			}
			rowExist.Close();

			myCommand.CommandText = sql;
			myCommand.ExecuteNonQuery(); 
			myConnection.Close();
		}

		//ڷ Ѿ ¥  Ѵ.
		public SqlDataReader GetDateContent(string userId, DateTime dtDate)
		{
			string sql = "Select *  From DailyPlan where rtUserID=@UserID and rtDate=@dtDate";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar)).Value = userId;
			myCommand.Parameters.Add(new SqlParameter("@dtDate", SqlDbType.DateTime)).Value = dtDate;

			myConnection.Open();
			SqlDataReader result = myCommand.ExecuteReader(CommandBehavior.CloseConnection);
            
			return result;
		}

		//ڷ Ѿ ¥  .
		public int DeleteDate(string userId, DateTime dtDate)
		{
			string sql = "delete DailyPlan where rtUserID=@UserID and rtDate=@dtDate";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar)).Value = userId;
			myCommand.Parameters.Add(new SqlParameter("@dtDate", SqlDbType.DateTime)).Value = dtDate;

			int result = 1;
			myConnection.Open();
			try
			{
				myCommand.ExecuteNonQuery();
			}
			catch
			{
				result = -1;
			}
			finally
			{
				myConnection.Close();
			}
            
			return result;
		}

		//ڷ Ѿ ¥     ´.
		public SqlDataReader ReadMonthList(string userId, DateTime dtDate)
		{
			DateTime startDate, endDate;

			string sqlList = "Select * From DailyPlan where rtUserID=@UserID and rtDate>=@startDate and rtDate<=@endDate Order By rtDate";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand(sqlList, myConnection);

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar)).Value = userId;

			startDate = GetStartDate(dtDate);
			endDate = GetEndDate(dtDate);

			SqlParameter parameterStartDate = new SqlParameter("@startDate", SqlDbType.DateTime);
			parameterStartDate.Value = startDate;
			myCommand.Parameters.Add(parameterStartDate);

			SqlParameter parameterEndDate = new SqlParameter("@endDate", SqlDbType.DateTime);
			parameterEndDate.Value = endDate;
			myCommand.Parameters.Add(parameterEndDate);

			myConnection.Open();
			SqlDataReader result = myCommand.ExecuteReader(CommandBehavior.CloseConnection);
            
			return result;
		}

		private DateTime GetStartDate(DateTime dtDate)
		{
			
			if (dtDate.Month == 1) //1̸  12
			{
				//޷¿ ޷ ǥõ ִ ִ 6̹Ƿ
				return new DateTime(dtDate.Year-1, 12, DateTime.DaysInMonth(dtDate.Year-1,12)-5);
			}
			else
			{
				//⵵  6ش.
				return new DateTime(dtDate.Year, dtDate.Month-1, DateTime.DaysInMonth(dtDate.Year,dtDate.Month-1)-5);
			}
		}

		private DateTime GetEndDate(DateTime dtDate)
		{
			if (dtDate.Month == 12) //12̸  1
			{
				//޷¿ ޷ ǥõ ִ ִ 6̹Ƿ
				return new DateTime(dtDate.Year+1, 1, 6);
			}
			else
			{
				//⵵  6 ش.
				return new DateTime(dtDate.Year, dtDate.Month+1, 6);
			}
		}
	}
}
