namespace PowerOfDotNet.NewStudy.Lacture
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using System.Text.RegularExpressions;

	/// <summary>
	///		LactureContentGroup   Դϴ.
	/// </summary>
	public abstract class LactureContentGroup : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.DataList GroupList;
		protected System.Web.UI.WebControls.DataList ContentList;
		//protected System.Web.UI.WebControls.Label Label1;
		private GroupInfo _groupInfo;

		public GroupInfo GroupInfo {
			get	{return _groupInfo;}
			set	{_groupInfo = value;}
		}

		private PowerOfDotNet.Components.BoardLactureInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			int boardId = Convert.ToInt32(Request.QueryString["TableId"]);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardLactureInfo)this.GetObjectFromCache("BoardLactureTableInfo" + boardId);
			if (_blInfo == null)
			{
				PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardLactureTableInfo" + boardId, _blInfo, 30);
			}
			//ContentList_ItemCommand ޼ҵ忡 ϱ 
			//̻ϰ ContentList_ItemCommandȿ  ä  ۵Ѵ.
			Context.Items["_blInfo"] = _blInfo;

			ContentList.DataSource = _groupInfo.IDs;
			ContentList.DataBind();

			GroupList.DataSource = CreateDataSource();
			GroupList.DataBind();

			if (IsPostBack)
			{
				//ContentList_ItemCommand ̻ϰ  Ŭ κ Ҽ .
				//ItemCommand ġ ޼ҵó ϴ  . 
				//this ٸ ä νĵȴ.
				//Context.Items[this] = _groupInfo;
				//׷ ̷   Ѵ.
				Context.Items[_groupInfo.GroupID.ToString()] = _groupInfo;
			}
		}

		// Խù  ̰ ϴ Ķ͸ Ѵ.
		//   ȣѴ.
		protected string GetContentUri(string id)
		{
			string orgUri = Request.RawUrl;
			string pattern = @"&group\d+=" + _groupInfo.GroupID.ToString() + ":[^&]+&";
			string retUri = "";
			Regex groupRegex = new Regex(pattern);

			//Խ ˻  ߰Ѵ.
			if (orgUri[orgUri.Length-1] != '&')
				orgUri += "&";
			Match m = groupRegex.Match(orgUri);
			if ( m.Success ) {
				string search = "=" + _groupInfo.GroupID.ToString();
				string newParm = m.Value.Substring(0, m.Value.IndexOf(search) + search.Length);
				newParm += ":" + id.ToString() + "&";
				retUri = groupRegex.Replace(orgUri, newParm);
			}
			else {
				throw new Exception("Uri Ķ  ߸Ǿϴ.");
			}

			return retUri;
		}

		//Ÿҽ 
		private ICollection CreateDataSource()
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("Writer", typeof(string)));
			dt.Columns.Add(new DataColumn("Viewed", typeof(Int32)));
			dt.Columns.Add(new DataColumn("RegDate", typeof(string)));
			dt.Columns.Add(new DataColumn("Space", typeof(string)));
			dt.Columns.Add(new DataColumn("IsNew", typeof(bool)));
			dt.Columns.Add(new DataColumn("CommandArgument", typeof(string)));

			PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
			SqlDataReader sdr = db.GetListByGroupID(_blInfo.BBSTable, _groupInfo.GroupID);

			while (sdr.Read()) {
				dr = dt.NewRow();

				dr[0] = sdr.GetInt64(0); //ID
				dr[1] = sdr.GetString(1); //Subject
				dr[2] = sdr.GetString(2); //Writer
				dr[3] = sdr.GetInt32(3); //ȸ
				dr[4] = sdr.GetDateTime(4).ToString("yyyy MM dd"); //RegDate
				DateTime dtRegDate = sdr.GetDateTime(4);
				dr[6] = dtRegDate >= DateTime.Now.AddDays(-1);//New ̹ ÷ 
				dr[7] = _groupInfo.GroupID.ToString() + ":" + sdr.GetInt64(0).ToString(); //Ŀ 

				string sEmail = sdr.GetString(5);
				// ּҰ  ũ
				if (sEmail != null && sEmail != String.Empty) {
					dr[2] = "<a href=\"mailto:" + sEmail + "\">" + dr[2] + "</a>";				
				}

				string sSpace = "";
				// 鿩
				for (int i=0;i<sdr.GetInt32(6);i++) 	sSpace += "&nbsp;&nbsp;";
				dr[5] = sSpace;

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
			this.ContentList.ItemCommand += new DataListCommandEventHandler(this.ContentList_ItemCommand);
		}
		#endregion

		//Request.RawUrl  ID  ּҸ Ѵ.
		protected string GetDeletedUri(string id, string groupId)
		{
			string orgUri = Request.RawUrl;
			string pattern = @"&group\d+=" + groupId + ":[^&]+&";
			string retUri = "";
			Regex groupRegex = new Regex(pattern);

			//Խ ˻  ߰Ѵ.
			if (orgUri[orgUri.Length-1] != '&')
				orgUri += "&";
			Match m = groupRegex.Match(orgUri);
			if ( m.Success )
			{
				string[] aTmp = m.Value.Split(new char[] {':'});
				// ޺κп & ڰ Ƿ Ѵ.
				string[] aIDs = aTmp[1].Replace("&", "").Split(new char[] {','});

				string paramIDs = "";
				foreach (string s in aIDs)
				{
					if (s != id) // idܿ ٸ id ߰Ѵ.
						paramIDs += "," + s;
				}
				if (paramIDs.Length > 0)
				{
					//Uri ׷ȿ ID ϳ ̻̾  ĶŸ 
					paramIDs = paramIDs.Substring(1); //  ',' 
					string search = "=" + groupId;
					string newParm = m.Value.Substring(0, m.Value.IndexOf(search) + search.Length);
					newParm += ":" + paramIDs + "&";
					retUri = groupRegex.Replace(orgUri, newParm);
				}
				else
				{
					//Uri ׷ȿ id ϳ ׷쵵 
					retUri = groupRegex.Replace(orgUri, "&");
				}
				//׷ ϳ     Ƿ
				//  Uri ؾѴ.
				pattern = @"&group\d+=\d+:[^&]+&";
				groupRegex = new Regex(pattern);
				m = groupRegex.Match(retUri);
				if (!m.Success)
				{
					retUri = GetLink(_blInfo.BBSPageNameList);
					string page = "&page=" + MyWebLibs.Utilities.CommonMethods.RequestStr(Request.QueryString["page"], "0");
					string tableId = "&TableId=" + Request.QueryString["TableId"].ToString();

					retUri += page + tableId;
				}
			}
			else
			{
				throw new Exception("Uri Ķ  ߸Ǿϴ.");
			}

			return retUri;
		}

		private void ContentList_ItemCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			string sCommandName = e.CommandName;
			string sCommandArgument = e.CommandArgument.ToString();

			string[] aCmd = sCommandArgument.Split(new Char[] {':'});

			PowerOfDotNet.Components.BoardLactureInfo blInfo = (PowerOfDotNet.Components.BoardLactureInfo)Context.Items["_blInfo"];

			switch (sCommandName)
			{
				case "Edit":
					// Uri Ķ͸  Ѵ.
					// ģ  ּҷ ٽ ƿü ֵ
					string retBefore = Request.RawUrl.Replace("&","$").Replace("=","^");
					string id = "id=" + aCmd[0];
					string genParam = LactureUtil.GetGenParam();
					Response.Redirect(GetLink(blInfo.BBSPageNameEdit) + "&" + id + "&" + genParam + "&TableId=" + aCmd[1] + "&before=" + retBefore);
					break;
				case "Delete":

					PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
					int result = db.DeleteOne(aCmd[2], int.Parse(aCmd[1]), int.Parse(aCmd[0]));
					if (result == -1)
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ־  ϴ.");
					else if (result == -2)
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Խù    ߻߽ϴ.");

					Response.Redirect(GetDeletedUri(aCmd[1], aCmd[0]));

					break;
				case "Reply":
					// Uri Ķ͸  Ѵ.
					// ģ  ּҷ ٽ ƿü ֵ
					string retRBefore = Request.RawUrl.Replace("&","$").Replace("=","^");
					string idR = "id=" + aCmd[0];
					string genParamR = LactureUtil.GetGenParam();
					Response.Redirect(GetLink(blInfo.BBSPageNameReply) + "&" + idR + "&" + genParamR + "&TableId=" + aCmd[1] + "&before=" + retRBefore);
					break;
			}
		}
	}
}
