namespace PowerOfDotNet.Shop
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Drawing.Imaging;
	using System.Drawing.Text;
	using System.Drawing.Drawing2D;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Reflection;
	using System.Collections;
	using System.IO;

	public abstract class ShopSetUpBothAltercast : PowerOfDotNet.PortalModuleControl
	{
		protected System.Web.UI.WebControls.TextBox txtAppendString;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstStringPlace;
		protected System.Web.UI.WebControls.Table tablColors;
		protected System.Web.UI.WebControls.Label lblSelectedColor;
		protected System.Web.UI.WebControls.TextBox txtSelectedColor;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.DropDownList drpdnlstStringFonts;
		protected System.Web.UI.WebControls.DropDownList drpdnlstStringFontSize;
		protected System.Web.UI.WebControls.ImageButton imgbtnOver;
		protected System.Web.UI.WebControls.CheckBox chkboxOverHAuto;
		protected System.Web.UI.WebControls.CheckBox chkboxOverVAuto;
		protected System.Web.UI.WebControls.TextBox txtOverRotate;
		protected System.Web.UI.WebControls.RangeValidator RangeValidator1;
		protected System.Web.UI.WebControls.DropDownList drpdnlstOverAlpha;
		protected System.Web.UI.WebControls.TextBox txtOverPercent;
		protected System.Web.UI.WebControls.RangeValidator RangeValidator2;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected System.Web.UI.WebControls.ImageButton ImageButton1;
		protected System.Web.UI.WebControls.LinkButton lnkbtnChangeOverImage;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnOpenOverManagerWin;
		protected System.Web.UI.WebControls.Image Image1;
		protected System.Web.UI.WebControls.Image Image2;
		protected System.Web.UI.WebControls.Button btnApply;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hiddenOverImage;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				Type colorType = typeof(Color);
				PropertyInfo[] aColorPropInfo = colorType.GetProperties();
				TableRow row = null;
				int count = 0;
				int length = aColorPropInfo.Length;
				foreach (PropertyInfo propInfo in aColorPropInfo)
				{
					if (propInfo.PropertyType.Name == "Color")
					{
						if (count % 15 == 0)
						{
							row = new TableRow();
							tablColors.Rows.Add(row);
						}

						TableCell cell = new TableCell();
						cell.Width = 7;
						cell.Height = 7;
						cell.BackColor = Color.FromName(propInfo.Name);
						cell.Attributes["onclick"] = "document.all['" + lblSelectedColor.ClientID + "']" + 
							".style.backgroundColor=this.style.backgroundColor;" +
							"document.all['" + txtSelectedColor.ClientID  + "']" + 
							".value='" + propInfo.Name + "'";
						
						if (count == length - 1)
							cell.ColumnSpan = count % 15;

						row.Cells.Add(cell);
						count++;
					}
				}

				InstalledFontCollection installedFontCollection = new InstalledFontCollection();
				FontFamily[] fontFamilies = installedFontCollection.Families;
				ArrayList aFonts = new ArrayList();

				foreach(FontFamily fontInfo in fontFamilies)
				{
					aFonts.Add(fontInfo.Name);
				}
				drpdnlstStringFonts.DataSource = aFonts;
				drpdnlstStringFonts.DataBind();

				for (int i=5;i<50; i++)
					drpdnlstStringFontSize.Items.Add(i.ToString());

				drpdnlstStringFontSize.SelectedIndex = 10;

				for (int i=1;i<=100; i++)
					drpdnlstOverAlpha.Items.Add(i.ToString());

				drpdnlstOverAlpha.SelectedIndex = 69;

				btnSubmit.Enabled = false;
				imgbtnOver.Attributes["disabled"] = "true";

				ViewState["overStringPosXY"] = new int[] {-1,-1};
				ViewState["overStringMethod"] = 1;

				hiddenOverImage.Value = "Over1.gif";
				btnOpenOverManagerWin.Disabled = true;
				btnApply.Enabled = false;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtnOver.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtnOver_Click);
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.ImageButton1.Click += new System.Web.UI.ImageClickEventHandler(this.ImageButton1_Click);
			this.lnkbtnChangeOverImage.Click += new System.EventHandler(this.lnkbtnChangeOverImage_Click);
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		private void ImageButton1_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			
			Confirm(1);
			btnSubmit.Enabled = true;
			btnOpenOverManagerWin.Disabled = false;
			btnApply.Enabled = true;
			imgbtnOver.Attributes.Remove("disabled");
		}

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			Confirm(2);
		}

		private void imgbtnOver_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Confirm(3);
		}

		private void lnkbtnChangeOverImage_Click(object sender, System.EventArgs e)
		{
			imgbtnOver.ImageUrl = "/Shop/Images/Sale/" + hiddenOverImage.Value;
			Confirm(2);
		}

		private void btnApply_Click(object sender, System.EventArgs e)
		{
			string appendString = txtAppendString.Text; 
			int stringPlace = int.Parse(rdobtnlstStringPlace.SelectedItem.Value); 
			string stringColor = txtSelectedColor.Text; 
			string stringFont = drpdnlstStringFonts.SelectedItem.Value;
			int stringSize = int.Parse(drpdnlstStringFontSize.SelectedItem.Value);
			string overImage = hiddenOverImage.Value;
			int[] overXY = (int[])ViewState["overXY"];
			int[] overStringPosXY = (int[])ViewState["overStringPosXY"];
			bool overStringHAuto = chkboxOverHAuto.Checked;
			bool overStringVAuto = chkboxOverVAuto.Checked;
			int originalSize = (int)ViewState["originalSize"];
			int overRotate;
			int overAlpha;
			int overPercent;

			try {
				overRotate = int.Parse(txtOverRotate.Text);
			}
			catch {
				overRotate = 0;
			}

			try {
				overAlpha = int.Parse(drpdnlstOverAlpha.SelectedItem.Value);
			}
			catch {
				overAlpha = 100;
			}

			try {
				overPercent = int.Parse(txtOverPercent.Text);
			}
			catch {
				overPercent = 100;
			}

			Components.ShopDB db = new Components.ShopDB();
			db.SaveAltercastImageInfo("S", appendString, 
				stringPlace, stringColor,	stringFont, 
				stringSize,	overImage, overXY[0], overXY[1],
				overRotate, overAlpha, overPercent, overStringPosXY[0], 
				overStringPosXY[1], overStringHAuto, overStringVAuto,
				originalSize);

			Response.Redirect(GetLink("θ"));
		}

		private void Confirm(int buttonNum)
		{
			string percentStr = "25";
			string appendString = txtAppendString.Text; 
			int stringPlace = int.Parse(rdobtnlstStringPlace.SelectedItem.Value); 
			string stringColor = txtSelectedColor.Text; 
			string stringFont = drpdnlstStringFonts.SelectedItem.Value;
			string stringSize = drpdnlstStringFontSize.SelectedItem.Value;
			string overImage = hiddenOverImage.Value;
			int[] overXY = null;
			int[] overStringPosXY;
			bool overStringHAuto = chkboxOverHAuto.Checked;
			bool overStringVAuto = chkboxOverVAuto.Checked;
			int overRotate;
			int overAlpha;
			int overPercent;

			if (buttonNum == 1)
			{
				overXY = Request.MapImageCoordinates(ImageButton1.UniqueID);
				overStringPosXY = (int[])ViewState["overStringPosXY"];
			}
			else if (buttonNum == 2)
			{
				overXY = (int[])ViewState["overXY"];
				overStringPosXY = (int[])ViewState["overStringPosXY"];
			}
			else
			{
				overXY = (int[])ViewState["overXY"];
				overStringPosXY = Request.MapImageCoordinates(imgbtnOver.UniqueID);
			}

			try 
			{
				overRotate = int.Parse(txtOverRotate.Text);
			}
			catch 
			{
				overRotate = 0;
			}

			try 
			{
				overAlpha = int.Parse(drpdnlstOverAlpha.SelectedItem.Value);
			}
			catch 
			{
				overAlpha = 100;
			}

			try 
			{
				overPercent = int.Parse(txtOverPercent.Text);
			}
			catch 
			{
				overPercent = 100;
			}

			// ̹ ĳϰֱ  ̹ 
			//̸ ٲ Ŭ̾Ʈ ĵ ̹ µȴ.
			string imgName = DateTime.Now.Ticks.ToString();
			//ImageButton1.ImageUrl = "/Shop/Images/CompositionImage" + imgName + ".gif";
			ImageButton1.ImageUrl = "/Shop/Images/CompositionImage" + imgName + "_0.gif";
			Image1.ImageUrl = "/Shop/Images/CompositionImage" + imgName + "_1.gif";
			Image2.ImageUrl = "/Shop/Images/CompositionImage" + imgName + "_2.gif";

			GenerateImage(percentStr, appendString, stringPlace, 
				stringColor, stringFont, stringSize, overImage, 
				overXY, overRotate, overAlpha, overPercent, 
				overStringPosXY, overStringHAuto, overStringVAuto, imgName);

			ViewState["overStringHAuto"] = overStringHAuto;
			ViewState["overStringVAuto"] = overStringVAuto;
			ViewState["overStringPosXY"] = overStringPosXY;
			ViewState["overXY"] = overXY;
		}

		private void GenerateImage(string percentStr, string appendString, 
			int stringPlace, string stringColor, string stringFont, 
			string stringSize, string overImage, int[] overXY, 
			int overRotate, int overAlpha, int overPercent, 
			int[] overStringPosXY, bool overStringHAuto, bool overStringVAuto, 
			string resultImageName)
		{

			Bitmap oBaseImage = new Bitmap(Page.MapPath("/Shop/Images/SampleBaseL.jpg"));
			Bitmap oOverImage = new Bitmap(Page.MapPath("/Shop/Images/Sale/" + overImage));

			//float overSizeRatio = (float)oOverImage.Width / (float)oBaseImage.Width * 100;
			int originalSize = oBaseImage.Width;
			ViewState["originalSize"] = originalSize;

			string[] aBaseImages = new string[3];
			aBaseImages[0] = "SampleBaseL.jpg";
			aBaseImages[1] = "SampleBaseM.jpg";
			aBaseImages[2] = "SampleBaseS.jpg";
			for (int i=0; i<3; i++)
			{
				oBaseImage = new Bitmap(Page.MapPath("/Shop/Images/" + aBaseImages[i]));
				Graphics oGraphics = Graphics.FromImage( oBaseImage );

				oGraphics.ResetTransform();

				//GraphicsContainer oGraphicsContainer = oGraphics.BeginContainer();

				//콺 ǥ  ̹  ó ̹
				// Ѵ.
				//̷ ؾ ̹ ũⰡ ٲ  µȴ.
				float scaleValue1 = (float)oBaseImage.Width / (float)originalSize;
				oGraphics.ScaleTransform(scaleValue1, scaleValue1);

				float scaleValue2 = (float)overPercent / 100;
				oGraphics.ScaleTransform(scaleValue2, scaleValue2, MatrixOrder.Append);

				int coordinateX = (int)(overXY[0] * scaleValue1);
				int coordinateY = (int)(overXY[1] * scaleValue1);

				//oGraphics.TranslateTransform(overXY[0], overXY[1], MatrixOrder.Append);
				oGraphics.TranslateTransform(coordinateX, coordinateY, MatrixOrder.Append);

				ColorMatrix myColorMatrix = new ColorMatrix();
				myColorMatrix.Matrix00 = 1.00f; // Red
				myColorMatrix.Matrix11 = 1.00f; // Green
				myColorMatrix.Matrix22 = 1.00f; // Blue
				myColorMatrix.Matrix33 = ((float)overAlpha / 100); // alpha
				myColorMatrix.Matrix44 = 1.00f; // w

				// Create an ImageAttributes object and set the color matrix.
				ImageAttributes imageAttr = new ImageAttributes();
				imageAttr.SetColorMatrix(myColorMatrix);

				Color lowerColor = Color.FromArgb(255,255,255);
				Color upperColor = Color.FromArgb(255,255,255);
				imageAttr.SetColorKey(lowerColor, upperColor);

				//Bitmap oOverImage = new Bitmap(Page.MapPath("ProdImgS_00010.jpg"));
				//Bitmap oOverImage = new Bitmap(Page.MapPath("./Image/Sale/" + overImage));

				oGraphics.RotateTransform(overRotate);

				oGraphics.CompositingMode = CompositingMode.SourceOver;
				Rectangle rectImg = new Rectangle(0, 0, oOverImage.Width, oOverImage.Height);
				oGraphics.DrawImage(oOverImage,         // Image
					rectImg,            // Dest. rect.
					0,               // srcX
					0,               // srcY
					oOverImage.Width,             // srcWidth
					oOverImage.Height,             // srcHeight
					GraphicsUnit.Pixel, // srcUnit
					imageAttr);      // ImageAttributes

				FontFamily fontFamily = new FontFamily(stringFont);
				Font font = new Font(
					fontFamily,
					int.Parse(stringSize), FontStyle.Bold,
					GraphicsUnit.Point);

				//overStringHAuto, overStringVAuto
				StringFormat stringFormat = new StringFormat();
				int rectStrX = 0;
				int rectStrY = 0;
				if (overStringPosXY[0] != -1 && !overStringHAuto)
					rectStrX = overStringPosXY[0];
				else // Center each line of text.
					stringFormat.Alignment = StringAlignment.Center;

				if (overStringPosXY[1] != -1 && !overStringVAuto)
					rectStrY = overStringPosXY[1];
				else // Center the block of text (top to bottom) in the rectangle.
					stringFormat.LineAlignment = StringAlignment.Center;

				//overStringPosXY, overStringMethod
				Rectangle rectStr = new Rectangle(rectStrX, rectStrY, oOverImage.Width, oOverImage.Height);
				SolidBrush solidBrush = new SolidBrush(Color.FromName(stringColor));

				string text = stringPlace == 1 ? appendString + percentStr : percentStr + appendString;
				oGraphics.DrawString(text, font, solidBrush, rectStr, stringFormat);

				//oGraphics.EndContainer(oGraphicsContainer);

				string [] files = Directory.GetFiles(MapPath("/Shop/Images/"), "CompositionImage*" + "_" + i + ".gif");
				foreach (string file in files)
					File.Delete(file);
			
				oBaseImage.Save(Page.MapPath("/Shop/Images/CompositionImage" + resultImageName + "_" + i + ".gif"), ImageFormat.Gif);

				oGraphics.Dispose();
			}
			
			oOverImage.Dispose();
			oBaseImage.Dispose();
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			if (IsPostBack)
			{
				lblSelectedColor.BackColor = Color.FromName(txtSelectedColor.Text);

				Type colorType = typeof(Color);
				PropertyInfo[] aColorPropInfo = colorType.GetProperties();
				TableRow row = null;
				int count = 0;
				int length = aColorPropInfo.Length;
				foreach (PropertyInfo propInfo in aColorPropInfo)
				{
					if (propInfo.PropertyType.Name == "Color")
					{
						if (count % 15 == 0)
						{
							row = new TableRow();
							tablColors.Rows.Add(row);
						}

						TableCell cell = new TableCell();
						cell.Width = 7;
						cell.Height = 7;
						cell.BackColor = Color.FromName(propInfo.Name);
						cell.Attributes["onclick"] = "document.all['" + lblSelectedColor.ClientID + "']" + 
							".style.backgroundColor=this.style.backgroundColor;" +
							"document.all['" + txtSelectedColor.ClientID  + "']" + 
							".value='" + propInfo.Name + "'";
						
						if (count == length - 1)
							cell.ColumnSpan = count % 15;

						row.Cells.Add(cell);
						count++;
					}
				}
			}
		}
	}
}
