using System;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// Clubs ϴ  ޼ҵ 
	/// </summary>
	public class ClubsUtil
	{
		//Ŭ  ϴ ClubInfo ü ȯѴ.
		static public Components.ClubInfo GetClubInfo(PortalModuleControlEx module, int clubId)
		{
			string casheKey = "objClub_" + clubId;
			Components.ClubInfo clubInfo = (PowerOfDotNet.Components.ClubInfo)module.GetObjectFromCache(casheKey);
			if (clubInfo == null)
			{
				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();

				//ClubInfo Ŭ  ϴ Ŭ  Ѵ.
				SqlDataReader drClub = db.GetClub(clubId);
				drClub.Read();
				clubInfo = new PowerOfDotNet.Components.ClubInfo();
				clubInfo.subject = drClub["Subject"].ToString();
				clubInfo.sysopId = drClub["SysopId"].ToString();
				clubInfo.viceSysopId = drClub["ViceSysopIDs"].ToString();
				clubInfo.sysopName = drClub["Name"].ToString();
				clubInfo.sysopEmail = drClub["Email"].ToString();
				clubInfo.memberCount = (int)drClub["MemberCount"];
				clubInfo.CreatedDate = (DateTime)drClub["CreatedDate"];
				clubInfo.frontTableName = drClub["FrontTableName"].ToString();
				clubInfo.introHtml = drClub["IntroHtml"].ToString();
				clubInfo.mainHtml = drClub["MainHtml"].ToString();
				clubInfo.skinType = (byte)drClub["skinType"];
				clubInfo.classId = (int)drClub["ClassID"];
				clubInfo.publicType = (byte)drClub["PublicType"];
				drClub.Close();

				SqlDataReader drClass = db.GetClass(clubInfo.classId);
				drClass.Read();
				clubInfo.className = drClass["Name"].ToString();
				clubInfo.classImagePath = drClass["ImagePath"].ToString();
				drClass.Close();

				//clubInfo ĳÿ 
				module.SetObjectToCache(casheKey, clubInfo, 20);
			}

			return clubInfo;
		}

		//Խù   ִ ˻Ѵ.jdwls^^

		static public bool CheckUserAuthority(string userId, Components.ClubInfo clubInfo)
		{
			//̰ų νû, Ʈ , Ŭä 
			if (userId == clubInfo.sysopId.Trim() || 
				FindMatch(userId, clubInfo.viceSysopId) || 
				CheckUserIsAdmin(userId))
				return true;
			else
				return false;
		}

		static public bool CheckUserAuthorityForGongJi(string userId, Components.ClubInfo clubInfo, Components.BoardClubInfo boardInfo)
		{
			// Խ ƴϸ
			if (boardInfo.BBSType != 0)
				return true;
			//̰ų νû, Ʈ , Ŭä 
			if (userId == clubInfo.sysopId.Trim() || 
				FindMatch(userId, clubInfo.viceSysopId) || 
				CheckUserIsAdmin(userId))
				return true;
			else
				return false;
		}

		static private bool FindMatch(string find, string search)
		{
			string[] aStr = search.Split(new char[] {';'});
			foreach (string s in aStr)
				if (s != String.Empty && find == s)
					return true;

			return false;
		}

		//Ŭ  ˻
		static public bool CheckUserIsAdmin(string userId)
		{
			string clubAuthRoles = ConfigurationSettings.AppSettings["ClubAuthRoles"];

			return PortalSecurity.IsInRoles(clubAuthRoles);
		}

		static public string GetGenParam()
		{
			HttpRequest Request = HttpContext.Current.Request;
			//ǵư ּҿ Ķ 
			string sqlParm = "";
			/*int sqlLev = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["sqllev"], 0);
			sqlParm = "sqllev=" + sqlLev.ToString();
			for (int i=0;i<sqlLev;i++)
			{
				int iTmp = i+1;
				sqlParm += "&sql"+iTmp.ToString() + "=" + 
					MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["sql" + iTmp.ToString()],"");
			}*/
			string page = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["page"], "");

			return "page=" + page + "&" + sqlParm;
		}
	}
}
