/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.MyPage
{
	using System;
	using System.Collections;
	using System.ComponentModel;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Drawing.Imaging;
	using System.Drawing.Text;
	using System.Web;
	using System.Web.SessionState;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Text;

	public abstract class UserAvatarManage : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.DataList datlstSaleAvatar1;
		protected System.Web.UI.WebControls.DataList datlstSaleAvatar2;
		protected System.Web.UI.WebControls.LinkButton lnkbtnSave;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hiddenSelectedItems;

		private void Page_Load(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();
			SqlDataReader drCategoryItem1 = db.GetItemsWhereCategory(3);
			datlstSaleAvatar1.DataSource = drCategoryItem1;
			datlstSaleAvatar1.DataBind();

			SqlDataReader drCategoryItem2 = db.GetItemsWhereCategory(4);
			datlstSaleAvatar2.DataSource = drCategoryItem2;
			datlstSaleAvatar2.DataBind();

			SqlDataReader drDefaultItems = db.GetItemsWhereCategory(1);
			while (drDefaultItems.Read())
			{
				Page.RegisterArrayDeclaration("aDefaultItemsID", drDefaultItems["ID"].ToString());
			}
			drDefaultItems.Close();

			MyWebLibs.Utilities.CommonMethods.RegisterOnloadFunction(this.Page, "SetupSlidLayer()");

			StringBuilder script = new StringBuilder();
			script.Append("\n<script language='JavaScript'>\n"); 
			script.Append("<!--\n");
			script.Append("	layerName='slidLayer';\n\n");
			script.Append("	var objPosition;\n");
			script.Append("	var objItem;\n\n");

			SqlDataReader drPositions = db.GetPositions();
			while (drPositions.Read())
			{
				int posId = (int)drPositions["PositionID"];
				script.Append("	objPosition = new Position(");
				script.Append(posId.ToString() + ",'" + 
					drPositions["Description"].ToString() + "'," + 
					((bool)drPositions["ExclusiveCircumference"]).ToString().ToLower());
				script.Append(");\n");
				script.Append("	objPosition.aDependedPosition = new Array();\n");

				SqlDataReader drDepPos = db.GetDependPositions(posId);
				while (drDepPos.Read())
				{
					script.Append("	objPosition.aDependedPosition[objPosition.aDependedPosition.length] = ");
					script.Append(drDepPos["AccessoryID"].ToString() + ";\n");
				}
				drDepPos.Close();

				SqlDataReader drPosAct = db.GetPositionAction(posId);
				while (drPosAct.Read())
				{
					//AddAction(occurrenceTime, action, targetCircumference, targetPositionId)
					script.Append("	objPosition.AddAction('");
					script.Append(drPosAct["OccurrenceTime"].ToString() + "','");
					script.Append(drPosAct["Action"].ToString() + "',");
					script.Append(drPosAct["TargetCircumference"].ToString().ToLower() + ",");
					script.Append(drPosAct["TargetPositionID"].ToString() + ");\n");
				}
				drPosAct.Close();

				script.Append("	positionInfo.aPosition[positionInfo.aPosition.length] = objPosition;\n");
			}
			drPositions.Close();

			script.Append("\n\n"); 
			SqlDataReader drItems = db.GetItems(String.Empty);
			while (drItems.Read())
			{
				int itemId = (int)drItems["ID"];
				script.Append("	objItem = new AvatarItem(");
				script.Append(itemId.ToString() + ",");
				script.Append(drItems["PositionID"].ToString() + ",");
				script.Append(drItems["Cost"].ToString() + ");\n");

				SqlDataReader drImages = db.GetItemImages(itemId);
				while (drImages.Read())
				{
					script.Append("	objItem.AddImagesInfo(");
					script.Append(drImages["LayerNum"].ToString() + ",'");
					script.Append(drImages["ImageName"].ToString() + "');\n");
				}
				drImages.Close();
				script.Append("	aExhibitionItems[FindEmptyPos(aExhibitionItems)] = objItem;\n");
			}
			drItems.Close();

			script.Append("	\n");
			script.Append("	objServerData = document.getElementById('" + hiddenSelectedItems.ClientID + "');\n");

			bool isDefault = true;
			//  
			if (Request.IsAuthenticated)
			{
				script.Append("	\n");
				SqlDataReader drUserItems = db.GetUserItems(this.Page.User.Identity.Name);
				while (drUserItems.Read())
				{
					script.Append("	PickItem(" + drUserItems["ItemID"].ToString() + ");\n");
					isDefault = false;
				}
				drUserItems.Close();
			}
			if (isDefault)
			{
				script.Append("	\n");
				script.Append("	DefaultItems();\n");
			}

			script.Append("// -->\n"); 
			script.Append("</script>\n"); 
			
			this.Page.RegisterStartupScript("AvatarDataScript", script.ToString()); 
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.lnkbtnSave.Click += new System.EventHandler(this.lnkbtnSave_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void lnkbtnSave_Click(object sender, System.EventArgs e)
		{
			if (Request.IsAuthenticated)
			{
				string[] aItemId = hiddenSelectedItems.Value.Split(new char[]{';'});
				PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();
				db.DeleteUserItems(this.Page.User.Identity.Name);

				foreach (string id in aItemId)
				{
					db.InsertUserItem(this.Page.User.Identity.Name, id);
				}
			}
			Response.Redirect(GetLink(""));
		}
	}
}
