/*
 *  - 2003 10 26
 */

namespace PowerOfDotNet.Templates
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	public abstract class HomeTemplate01 : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.HtmlControls.HtmlTableCell ContentPane;
		protected System.Web.UI.HtmlControls.HtmlTableCell RightPane;
		protected System.Web.UI.HtmlControls.HtmlTableCell LeftPane;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
				this.Page.DataBind();
		}

		override protected void OnInit(EventArgs e)
		{
			//base.OnInit  ȣϴ  ϴ.
			base.OnInit(e);

			InitializeComponent();

			//  PortalSettings ü ´.
			PortalSettings portalSettings = (PortalSettings) HttpContext.Current.Items["PortalSettings"];
        
			// Ensure that the visiting user has access to the current page
			// ǰ  ׼   ˻Ѵ.
			if (PortalSecurity.IsInRoles(((TabStripDetails)portalSettings.DesktopTabs[portalSettings.ActivePage.TabIndex]).AuthorizedRoles) == false ||
				PortalSecurity.IsInRoles(portalSettings.ActivePage.AuthorizedRoles) == false) 
			{
				if (!PortalSecurity.IsInRole("Users"))
					Response.Redirect(GetLink("α") + "&ReturnUrl=" + Request.RawUrl.Replace("&","$"));
				else
					Response.Redirect("~/Admin/AccessDenied.aspx");
			}

			// ActivePage.Modules.Count  Ե  
			if (portalSettings.ActivePage.Modules.Count > 0) {

				// û   ⿡  ݺѴ.
				foreach (ModuleSettings _moduleSettings in portalSettings.ActivePage.Modules) {
					//˻ϴ Control ø ̹  
					//Ƿ FindControlδ ã.
					Control parent = MyWebLibs.Utilities.CommonMethods.FindControlAll(this, _moduleSettings.PaneName);

					//  ĳϵ   ƴ  ó  ٸ.
					if ((_moduleSettings.CacheTime) == 0) {
						//PortalModuleControl Ʈ 
						PortalModuleControl portalModule = (PortalModuleControl) Page.LoadControl(_moduleSettings.DesktopSrc);
                   
						portalModule.PortalId = portalSettings.PortalId;                                  
						portalModule.ModuleConfiguration = _moduleSettings;
                   
						parent.Controls.Add(portalModule);
					}
					else {
						//CachedPortalModuleControl Ʈ 
						CachedPortalModuleControl portalModule = new CachedPortalModuleControl();
                   
						portalModule.PortalId = portalSettings.PortalId;                                 
						portalModule.ModuleConfiguration = _moduleSettings;
 
						parent.Controls.Add(portalModule);
					}

					parent.Visible = true;
				}
			}
		}
		
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
	}
}
